SystemOrganization addCategory: 'OrbeonBPMRuntime'!

!BlockClosure methodsFor: '*orbeonBPMRuntime' stamp: 'BrunoBB 11/13/2016 09:39'!
asBpmBlock

	^BpmCodeCondition fromBlock: self! !

!OrbeonProcessWebLocalLogin methodsFor: '*orbeonBPMRuntime' stamp: 'BrunoBB 12/08/2015 09:37'!
validateUser: username password: password

	^BpmUser cache anySatisfy: [:each | each username = username and:[each password = password]]! !

OrbeonBpmException subclass: #AbortionNotConfirmedException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #BasicUserBoxNotFoundException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #CategoryWithNoNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #EventInstanceNotFoundException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #GatewayIsNotRunningException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #NoMatrixForApplicationException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #NoMatrixSlotException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #NoNextArtifactBpmException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #NoProcessMatrixException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #NoProcessToMatrixMoveException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #NoRunningTaskException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #NoSuchTaskAssignmentException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #ProcessDefinitionNotFoundException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #ProcessDefinitionWithoutTimerException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

OrbeonBpmException subclass: #ProcessNotRunningException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmProcessDefinition methodsFor: '*orbeonBPMRuntime' stamp: 'BrunoBB 11/29/2015 17:29'!
getProcessInstanceClass

	^BpmProcessInstance! !

BpmObject subclass: #BpmArtifactInstance
	instanceVariableNames: 'definition id process inTransitions outTransitions creationTime state exceptions endTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmArtifactInstance subclass: #BpmActivityInstance
	instanceVariableNames: 'loopCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmActivityInstance subclass: #BpmAbstractTaskInstance
	instanceVariableNames: 'attachedEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmAbstractTaskInstance methodsFor: 'Accessing' stamp: 'brunobb 10/17/2017 12:48'!
attachedEvents
	^attachedEvents! !

!BpmAbstractTaskInstance methodsFor: 'Updating' stamp: 'brunobb 10/17/2017 12:48'!
attachedEvents: newValue
	attachedEvents := newValue! !

!BpmAbstractTaskInstance methodsFor: 'events' stamp: 'brunobb 10/18/2017 13:03'!
attachEvent: aBpmEventInstance

	aBpmEventInstance attachedTask: self.
 
	^attachedEvents add: aBpmEventInstance! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/04/2017 12:57'!
countExecutionTime

	^self expectedExecutionTime countExecutionTimeFrom: creationTime! !

!BpmAbstractTaskInstance methodsFor: 'process execution' stamp: 'brunobb 10/25/2017 07:21'!
createAttachedEventsIn: aBpmProcessInstance
	" The event definitions <BpmEventDefinition> attached to the receiver are created as concrete instances of <BpmEventInstance>"

	"for now only -TimerEvents- are created attached to its Task. In the future other EventInstances should be created as we complete the BPMN standart"

	(self getAttachedEventDefinitions select: [:eventDefinition | eventDefinition isTimerEvent]) do: [:eventDefinition | | eventInstance |
			eventInstance := eventDefinition createInstanceOn: aBpmProcessInstance.
			eventInstance trigger: self;
				performInitializationOn: aBpmProcessInstance attachTo: self.
			self defaultTimerEventMonitor startMonitoringArtifact: eventInstance.
	].! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/08/2017 10:17'!
dueDate
	"Answer the due date <aTimeStamp> of the receiver"

	^self expectedExecutionTime getDueDateFrom: creationTime! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/04/2017 11:09'!
expectedExecutionTime

	^definition expectedExecutionTime! !

!BpmAbstractTaskInstance methodsFor: 'process execution' stamp: 'brunobb 10/28/2017 15:50'!
finalize

	super finalize.

	attachedEvents do: [:event | event finalize].! !

!BpmAbstractTaskInstance methodsFor: 'process execution' stamp: 'brunobb 11/03/2017 05:11'!
finalizeWithoutAttachedEvents
	"This method finalize the receiver but without finalizing receiver's <attachedEvents>.
	When an attached event <isInterrupting> then the task is finalized by the event. 
	This method is used to avoid an infinit loop because the task finalized all <attachedEvents> then the interrupting attached event finalize the task and so on ...."

	super finalize! !

!BpmAbstractTaskInstance methodsFor: 'process execution' stamp: 'brunobb 10/18/2017 13:26'!
getAttachedEventDefinitions

	 ^definition attachedEvents! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/04/2017 12:29'!
getExpectedTimeWarningColor
	"The receiver answer the warning color of the execution time"

	self hasExpectedExecutionTime ifFalse: [^nil].

	^self expectedExecutionTime getWarningColorFrom: self! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/06/2017 15:28'!
getWarningColor

	^self expectedExecutionTime getWarningColorFrom: creationTime! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/04/2017 11:09'!
hasExpectedExecutionTime

	^definition hasExpectedExecutionTime! !

!BpmAbstractTaskInstance methodsFor: 'other' stamp: 'brunobb 10/17/2017 12:49'!
initialize

	super initialize.

	attachedEvents := OrderedCollection new.! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/04/2017 12:23'!
isOverdue

	^self hasExpectedExecutionTime 
		ifTrue: [self expectedExecutionTime isOverdueFrom: creationTime] 
		ifFalse: [false]! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/07/2017 05:50'!
printDueDate
	"Answer the due date <aTimeStamp> of the receiver"

	^self dueDate printString! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/06/2017 14:34'!
printTimeToDueDate
	| timeToDueDate printLabel |

	printLabel := PrintStream on: String new.
	timeToDueDate := self timeToDueDate.

	(timeToDueDate days ~= 0) ifTrue: [printLabel nextPutAll: timeToDueDate days printString, 'd:'].

	(timeToDueDate hours ~= 0) ifTrue: [printLabel nextPutAll: timeToDueDate hours printString, 'h:'].

	printLabel nextPutAll:  timeToDueDate minutes printString, 'm'.

	^printLabel contents! !

!BpmAbstractTaskInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/06/2017 14:36'!
timeToDueDate
	"Answer a time stamp representing the time to reach due date"

	^self dueDate - TimeStamp current! !

BpmAbstractTaskInstance subclass: #BpmSubProcessTaskInstance
	instanceVariableNames: 'processInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmSubProcessTaskInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 09:27'!
getTotalTime

	^processInstance getTotalTime! !

!BpmSubProcessTaskInstance methodsFor: 'other' stamp: 'brunobb 11/02/2017 13:24'!
isDone

	^processInstance hasFinalized! !

!BpmSubProcessTaskInstance methodsFor: 'process execution' stamp: 'brunobb 10/17/2017 13:14'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	processInstance := definition createProcessInstance: nil.

	aBpmProcessInstance addSubProcess: processInstance. "here also set the parent process"

	processInstance creatorTask: self;
		triggerStartEvent.

	self createAttachedEventsIn: aBpmProcessInstance. "create the attached event instances of the receiver "! !

!BpmSubProcessTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/01/2015 11:52'!
processInstance
	^processInstance! !

!BpmSubProcessTaskInstance methodsFor: 'Updating' stamp: 'BrunoBB 12/01/2015 11:52'!
processInstance: newValue
	processInstance := newValue! !

!BpmSubProcessTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:52'!
summaryTitle

	^'Sub Process'! !

BpmAbstractTaskInstance subclass: #BpmTaskInstance
	instanceVariableNames: 'rolesWhoWorked externalObject usersWhoWorked finalizedPerformerCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmTaskInstance commentStamp: 'BrunoBB 11/01/2015 12:52' prior: 0!
finalizedPerformerCount - used with performers only (is 0 for task without performers)
rolesWhoWorked - a collection to support multiple roles working on the same task. Each time role work finish a part of the task --> "finish" it's task and that roles is added to this collection.

Subclassses of this class must implement the following messages:
#getValueOfFormField:
#hasFieldNamed:

These methods are called from BpmProcessInstance>>doesNotUnderstand: when evaluating a BpmCode.!

BpmTaskInstance subclass: #BpmOrbeonTaskInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 08:57'!
formDefinition

	^externalObject definition! !

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:54'!
formSummaryFields
	"Answer the form of the receiver <anOrbeonFormDefinition> "

	^self formDefinition summaryFields! !

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 08:57'!
getOrbeonFormId

	^externalObject id! !

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:55'!
getSummaryFieldsValues
	"Answer a dictionary with the values of the summary fields.
	Key (field name) >> Value (value of the field)"
	| values |

	values := Dictionary new.
	self hasForm ifFalse: [^values].
	self formSummaryFields do: [:each | values at: each put: (self getValueOfFormField: each)].

	^values! !

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:42'!
getUserName

	externalObject ifNil: [^''].

	^externalObject valueAt: 'username'! !

!BpmOrbeonTaskInstance methodsFor: 'integration methods' stamp: 'BrunoBB 12/15/2015 08:57'!
hasFieldNamed: aSymbol
	"Answer whether or not the receiver has a field named <aSymbol>"

	^externalObject hasFieldNamed: aSymbol! !

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 14:44'!
renderHtmlOn: html for: waProcessBrowser

	^waProcessBrowser renderOrbeonLinkIconOn: html for: self! !

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 04/29/2016 12:16'!
serviceIds

	^Dictionary new
		at: 'processid' put: self processId printString;
		yourself! !

!BpmOrbeonTaskInstance methodsFor: 'other' stamp: 'BrunoBB 05/16/2016 12:29'!
summaryTitle

	^'Form'! !

BpmTaskInstance subclass: #BpmSeasideTaskInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmSeasideTaskInstance methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:42'!
getUserName

	externalObject ifNil: [^''].

	^externalObject getUserName! !

!BpmSeasideTaskInstance methodsFor: 'integration methods' stamp: 'BrunoBB 12/15/2015 08:58'!
hasFieldNamed: fieldName
	"Answer whether or not the receiver has a field named <aSymbol>"

	^externalObject class canUnderstand: fieldName asSymbol! !

!BpmSeasideTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 14:45'!
renderHtmlOn: html for: waProcessBrowser

	^waProcessBrowser renderSeasideFormLinkIconOn: html for: self! !

!BpmSeasideTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 11:44'!
summaryTitle

	^'Customized Task'! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 04/12/2016 13:28'!
addWorkerUser: aBpmUser as: aBpmRole
	"The receiver add a user <aBpmUser> who has worked and finish it's part of the task with the role <aBpmRole>"

	rolesWhoWorked add: aBpmRole.

	usersWhoWorked add: aBpmUser.! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/04/2015 09:56'!
asAssignmentFor: aBpmRole in: aBpmRunningTasksMatrix
	"The receiver answer a task assignment for a <BpmRole> based on it self"

	^(BpmTaskAssignment newFor: process task: self in: aBpmRunningTasksMatrix)
			roleName: aBpmRole name;
			yourself! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 04/12/2016 12:12'!
canCloseAndSend
	"Answer whether or not the receiver can be closed and send to the next task"

	^self hasPerformers 
	ifFalse: ["no <performers> --> can close and send"
		self isDone not and: [self hasForm] ]
	ifTrue: [self isFinishedByPerformers] "with <performers> --> can close and send only if all performers updated the receiver"! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 04/13/2016 11:49'!
canCloseAndSendPerformer: aBpmUser
	"Answer whether or not the user <aBpmUser> can close and send the receiver"

	^self innerTaskHasIsPendingBy:  aBpmUser! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 09:11'!
expectedResultValues
	"Answer aDictionary where the keys are the names of the fields of the Previous(parent) Transition, and the values are the values of each field in the previous transition"
	| resultValues |

	resultValues := Dictionary new.
	definition getExpectedResult do: [:each | 
		resultValues at: each put: (process getValueOfProcessField: each)].

	^resultValues! !

!BpmTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/15/2015 08:56'!
externalObject
	^externalObject! !

!BpmTaskInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/15/2015 11:45'!
externalObject: anObjectModel

	externalObject := anObjectModel.
	state := #processing.! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 07:41'!
finalize
	"The receiver finalize it self by calling the process <aBpmProcessInstance> to finalize it"

	super finalize.

	^process moveFromCurrentToExecuted: self! !

!BpmTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 04/13/2016 09:32'!
finalizedPerformerCount
	^finalizedPerformerCount! !

!BpmTaskInstance methodsFor: 'Updating' stamp: 'BrunoBB 04/13/2016 09:32'!
finalizedPerformerCount: newValue
	finalizedPerformerCount := newValue! !

!BpmTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 04/13/2016 09:32'!
finalizedPerformerCounter
	^finalizedPerformerCounter! !

!BpmTaskInstance methodsFor: 'Updating' stamp: 'BrunoBB 04/13/2016 09:32'!
finalizedPerformerCounter: newValue
	finalizedPerformerCounter := newValue! !

!BpmTaskInstance methodsFor: 'integration methods' stamp: 'BrunoBB 04/09/2016 13:42'!
getBasicValueOfFormField: fieldName
	"Answer the value of the field named <fieldName>"

	externalObject ifNil: [^nil].

	^externalObject valueAt: fieldName! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:18'!
getComponentClass

	^definition getComponentClass! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 01/17/2016 12:53'!
getCurrentPerformerIfNone: aBlock
	"The receiver answer the current <performer> that is working now"

	rolesWhoWorked isEmpty ifTrue: [^self getPerformers first].

	^(self getPerformers at: rolesWhoWorked size)! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 04/11/2016 12:26'!
getCurrentRoleIfNone: aBlock
	"The receiver answer the current <role> that is working now"

	^(self getCurrentPerformerIfNone: [^aBlock value]) ifNotNil: [:performer | self getRoleForPerformer: performer]! !

!BpmTaskInstance methodsFor: 'other' stamp: 'brunobb 12/21/2017 12:34'!
getFieldValues
	"Answer <aDictionary> where each key is the name of the field and the value is <anAppFieldValueHolder>"

	^externalObject fieldsValues! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 04/11/2016 09:36'!
getNextPerformerIfNone: aBlock
	"The receiver answer the next <performer> that is working now"

	rolesWhoWorked isEmpty ifTrue: [^self getPerformers first].

	(rolesWhoWorked size = self getPerformers size) ifTrue: [^self getPerformers last].

	^(self getPerformers at: rolesWhoWorked size + 1)! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 04/11/2016 12:26'!
getNextRoleIfNone: aBlock
	"The receiver answer the next <role> that is working now"

	^(self getNextPerformerIfNone: [^aBlock value]) ifNotNil: [:performer | self getRoleForPerformer: performer]! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:33'!
getObjectModel

	^definition getObjectModel! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 12:27'!
getRoleForPerformer: aBpmRoleParticipantDefinition

	^definition getRoleForPerformer: aBpmRoleParticipantDefinition! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:42'!
getUserName

	^self subclassResponsibility! !

!BpmTaskInstance methodsFor: 'integration methods' stamp: 'BrunoBB 04/09/2016 10:18'!
getValueOfFormField: fieldName
	"Answer the value of the field named <fieldName>"

	externalObject ifNil: [^nil].

	^externalObject fieldValueAt: fieldName! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 08:59'!
hasForm

	^externalObject notNil! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 09:31'!
incrementPerformerCounter
	"Increment by 1 the number of inner tasks (of a task) finished by performers"

	^finalizedPerformerCounter := finalizedPerformerCounter + 1! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 09:32'!
initialize

	super initialize.

	finalizedPerformerCounter := 0. "used with performers only (is 0 for task without performers)"

	rolesWhoWorked := OrderedCollection new.

	usersWhoWorked := OrderedCollection new.! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 04/13/2016 11:41'!
innerTaskHasBeenFinalizedBy: aBpmUser
	"Answer whether or not the user <aBpmUser> has finalized his part as performer of the task.
	Only applicable to tasks with performers"

	^(usersWhoWorked indexOf: aBpmUser ifAbsent: [^false]) = finalizedPerformerCounter! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 04/13/2016 11:48'!
innerTaskHasIsPendingBy: aBpmUser
	"Answer whether or not the user <aBpmUser> has a pending inner task as performer of this task.
	Only applicable to tasks with performers"

	^(self innerTaskHasBeenFinalizedBy: aBpmUser) not! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 12:35'!
isCreated

	^self hasForm! !

!BpmTaskInstance methodsFor: 'process execution' stamp: 'brunobb 11/02/2017 13:24'!
isDone
	"The receiver answer whether or not it'has been finalized.
	Check in collection <executedActivities> of it's process"

	^self process taskIsDone: self! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 01/18/2016 16:13'!
isFinishedByPerformers
	"Answer whether or not in the receiver has worked all defined <performers>, only then the receiver can be close and send"

	^rolesWhoWorked size = self getPerformers size! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 07/31/2016 13:27'!
isTask

	^true! !

!BpmTaskInstance methodsFor: 'process execution' stamp: 'brunobb 10/17/2017 13:00'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	"if it is not multi instance and a task with the same name is already executed --> take the form (previousTask externalObject) and set it to the new task"
	(self isMultiInstance not and: [aBpmProcessInstance hasExecutedActivityNamed: self getDefinitionName])
	ifTrue: [ | previousTask | 
		previousTask := aBpmProcessInstance getExecutedActivityNamed: self getDefinitionName ifNone: [].
		self externalObject: previousTask externalObject].

	self createAttachedEventsIn: aBpmProcessInstance. "create the attached event instances of the receiver "

	^aBpmProcessInstance addActivityToPerform: self "add the task to the Running Matrix"! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 13:45'!
previousFieldValues
	"Answer aDictionary where the keys are the names of the fields of the Previous(parent) Transition, and the values are the values of each field in the previous transition"
	| previousFieldValues |

	previousFieldValues := Dictionary new.
	definition getPreviousFields do: [:each | 
		previousFieldValues at: each put: (process getBasicValueOfProcessField: each)].

	^previousFieldValues! !

!BpmTaskInstance methodsFor: 'performers' stamp: 'BrunoBB 01/18/2016 09:51'!
removeLastWorker
	"The receiver remove the last worker (user and role).
	Used with <performers> when #untake: aBpmTaskAssignment"

	(rolesWhoWorked isEmpty or: [usersWhoWorked isEmpty]) ifTrue: [^self].

	rolesWhoWorked removeLast.
	usersWhoWorked removeLast.! !

!BpmTaskInstance methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 14:44'!
renderHtmlOn: html for: waProcessBrowser

	^self subclassResponsibility! !

!BpmTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 10:36'!
rolesWhoWorked
	^rolesWhoWorked! !

!BpmTaskInstance methodsFor: 'Updating' stamp: 'BrunoBB 12/15/2015 11:46'!
rolesWhoWorked: newValue

	rolesWhoWorked := newValue! !

!BpmTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 01/17/2016 11:28'!
usersWhoWorked
	^usersWhoWorked! !

!BpmTaskInstance methodsFor: 'Updating' stamp: 'BrunoBB 01/17/2016 11:28'!
usersWhoWorked: newValue
	usersWhoWorked := newValue! !

!BpmActivityInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 12:53'!
loopCounter
	^loopCounter! !

!BpmActivityInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/01/2015 12:53'!
loopCounter: newValue
	loopCounter := newValue! !

BpmActivityInstance subclass: #BpmGatewayInstance
	instanceVariableNames: 'isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmGatewayInstance subclass: #BpmComplexGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmComplexGateway commentStamp: 'BrunoBB 11/24/2015 13:13' prior: 0!
Splitting

It is similar to an Inclusive Gateway. The difference lies in that it uses a single outgoing assignment within the Gateway instead of a set of conditions over the outgoing paths. The result is the same in the sense that one or more outgoing paths will be activated.

In general, one assignment has two parts: a condition and an action. When an assignment is executed, its condition is evaluated and if it is true, the action is performed; this action can be the updating a property of the process or a Data Object. In the case of a Complex Gateway, the outgoing assignment may refer to process data or its Data Objects and the status of its incoming paths (e.g. if the flow will come from a certain path in a certain process instance). For example, an outgoing assignment may evaluate process data and then select different sets of outgoing paths depending on the results of the evaluation. However, the outgoing assignment should ensure that at least one path will be chosen.

Merging

In this case, an incoming assignment is used when the flow reaches the Gateway. The condition may refer to the same data as in the Splitting behavior of the Complex Gateway (process data, Data Objects, etc.). If the condition evaluates to false, nothing happens except for the fact that the flow is stopped in the Gateway. If it evaluates to true, the action could be to let the flow continue or stop it.

Since the use of the Complex Gateway to merge paths can vary depending on the purpose for which it is used, modelers are recommended to use text annotations to inform the diagram readers about the behavior being assigned to the Gateway.

An example of use would be the discriminator pattern. In this pattern, there are two or more parallel tasks which are merged in a Complex Gateway. When one of the activities is completed, the following tasks can be started. It doesnt matter which activity is completed first. The other tasks are completed normally but they wont affect the process flow, that is to say, new instances of the following tasks will not be generated.!

!BpmComplexGateway methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:39'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"! !

BpmGatewayInstance subclass: #BpmEventBasedGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmEventBasedGateway commentStamp: 'BrunoBB 11/24/2015 13:13' prior: 0!
Splitting

This type of Gateway requires the use of one or more catching Intermediate Events. The valid types of events are as follows:
    Message
    Timer
    Conditional
    Signal

Receive tasks can be used instead of Message events, but they can't be mixed. 
It should be pointed out that if none of the events specified occur, the process will be stuck. Therefore, a Timer event is recommended as an alternative.

Merging

It works in the same way as the Exclusive Gateway.
(It merges the flow without making any synchronizations)!

BpmGatewayInstance subclass: #BpmExclusiveEventBasedGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmGatewayInstance subclass: #BpmExclusiveGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmExclusiveGateway commentStamp: 'BrunoBB 11/24/2015 13:13' prior: 0!
Splitting

This type of Gateway divides the flow into two or more paths but the process flow will go down only one of these paths. Conditions are expressed as Gateway attributes and can be expressed in natural language or as formal expressions. The selection of the path to follow will be based on the evaluation of the conditions set for each path. They are evaluated one at a time, in the order in which they were defined in the Gateway (which doesn't mean that their corresponding paths are evaluated as displayed in the diagram) and the path corresponding to the first condition that evaluates to true will be selected. If none of the conditions is true, the process will be stuck in the Gateway. In this case, the use of default paths is suggested.


Merging

It merges the flow without making any synchronizations.!

!BpmExclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 07/02/2016 13:28'!
evaluateOutgoingTransitionsOn: aBpmProcessInstance
	"The receiver is Splitting and only one of all out going transition is going to be instantiated based on the evaluation of the condition"
	| nextTransitionDef |

	self getOutTransitionDefinitions do: [:trDefinition | 
		(nextTransitionDef isNil and: [trDefinition evaluateConditionIn: aBpmProcessInstance])
		ifTrue: [nextTransitionDef := trDefinition]. "if more than one condition is true --> answer the first one  (check <nextTransitionDef> ifNil)"
	].

	^nextTransitionDef 
	ifNotNil: [aBpmProcessInstance createNewTransition: nextTransitionDef from: self]
	ifNil: [self defaultTransition 
					ifNotNil: [:trDefinition | aBpmProcessInstance createNewTransition: trDefinition from: self]
					ifNil: [self signal: (NoNextArtifactBpmException signal: 'No next Task to execute')]].! !

!BpmExclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 16:49'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	isClosed ifTrue: [^self]. "a transition has already triggered the receiver so there is nothing to do"

	self isSplitting 
	ifTrue: [aBpmProcessInstance finalizeGateway: self.
				self evaluateOutgoingTransitionsOn: aBpmProcessInstance].

	isClosed := true.

	self isMerging 
	ifTrue: [aBpmProcessInstance finalizeGateway: self.
				aBpmProcessInstance generateNextTransitionsFrom: self].! !

!BpmGatewayInstance methodsFor: 'other' stamp: 'BrunoBB 01/22/2016 12:08'!
incomingTransitionsAreDone
	"Answer whether or not the receiver has ALL incoming transitions done. Which means that ALL incoming transitions in the definition has been instanciated"
	| inTransitionDefinitions |

	"collect the definitions of all concrete incoming transitions"
	inTransitionDefinitions := inTransitions collect: [:each | each definition]. 

	"all <inTransitions> in the definition of the receiver has been instanciated ?"
	^definition inTransitions allSatisfy: [:each | inTransitionDefinitions includes: each]! !

!BpmGatewayInstance methodsFor: 'other' stamp: 'BrunoBB 11/24/2015 13:14'!
initialize

	super initialize.

	isClosed := false! !

!BpmGatewayInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/24/2015 13:13'!
isClosed
	^isClosed! !

!BpmGatewayInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/24/2015 13:13'!
isClosed: newValue
	isClosed := newValue! !

!BpmGatewayInstance methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 17:02'!
isMerging
	"Answer whether or not the receiver is merging the process path"

	^definition isMerging! !

!BpmGatewayInstance methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 17:02'!
isSplitting
	"Answer whether or not the receiver is splitting the process path"

	^definition isSplitting! !

!BpmGatewayInstance methodsFor: 'other' stamp: 'BrunoBB 11/20/2015 12:48'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"! !

!BpmGatewayInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:52'!
summaryTitle

	^'Gateway'! !

BpmGatewayInstance subclass: #BpmInclusiveGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmInclusiveGateway commentStamp: 'BrunoBB 11/24/2015 13:13' prior: 0!
Splitting

Its behavior is similar to the Exclusive Gateway in the sense that it allows for the creation of multiple alternative paths based on conditions imposed on those paths. The difference lies in that more than one path can be chosen, that is, all those whose corresponding conditions evaluate to true. In this case, the use of default paths is recommended in order to prevent the process from getting stuck in any situation.

Merging

It works similarly to a Parallel Gateway merging in the sense that it synchronizes all incoming paths. Unlike the Parallel Gateway, it only synchronizes those paths that actually reach the Gateway, which are not necessarily all the incoming paths in the diagram; this could be specific to each process instance.!

!BpmInclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 07/02/2016 14:31'!
evaluateOutgoingTransitionsOn: aBpmProcessInstance
	"The receiver is Splitting and only one of all out going transition is going to be instantiated based on the evaluation of the condition"
	| nextTransitionsDef |

	nextTransitionsDef := OrderedCollection new.

	self getOutTransitionDefinitions do: [:trDefinition | 
		(trDefinition evaluateConditionIn: aBpmProcessInstance)
		ifTrue: [nextTransitionsDef add: trDefinition]. 
	].

	nextTransitionsDef do: [:each | aBpmProcessInstance createNewTransition: each from: self].

	nextTransitionsDef isEmpty 
	ifTrue: [self defaultTransition 
					ifNotNil: [:trDefinition | aBpmProcessInstance createNewTransition: trDefinition from: self]
					ifNil: [self signal: (NoNextArtifactBpmException signal: 'No next Task to execute')]].! !

!BpmInclusiveGateway methodsFor: 'other' stamp: 'BrunoBB 07/01/2016 07:36'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	isClosed ifTrue: [^self]. "a transition has already triggered the receiver so there is nothing to do"

	self isSplitting 
	ifTrue: [aBpmProcessInstance finalizeGateway: self.
				self evaluateOutgoingTransitionsOn: aBpmProcessInstance].

	self isMerging 
	ifTrue: [self incomingTransitionsAreDone "all path has been synchronized ?"
				ifTrue: [	isClosed := true.
							aBpmProcessInstance finalizeGateway: self.
							aBpmProcessInstance generateNextTransitionsFrom: self]
	].! !

BpmGatewayInstance subclass: #BpmParallelEventBasedGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmGatewayInstance subclass: #BpmParallelGateway
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmParallelGateway commentStamp: 'BrunoBB 11/24/2015 13:13' prior: 0!
Splitting

It simply divides the flow in two or more parallel paths. No conditions are evaluated.

Merging 

It synchronizes all the paths that arrive to the Gateway!

!BpmParallelGateway methodsFor: 'other' stamp: 'BrunoBB 07/02/2016 13:23'!
evaluateOutgoingTransitionsOn: aBpmProcessInstance
	"The receiver is Splitting and only one of all out going transition is going to be instantiated"

	"in parallel gateway no conditions are evaluated, all outgoing transitions are instantiated"

	self getOutTransitionDefinitions do: [:each | aBpmProcessInstance createNewTransition: each from: self].

	self getOutTransitionDefinitions isEmpty 
	ifTrue: [self defaultTransition 
				ifNotNil: [:trDefinition | aBpmProcessInstance createNewTransition: trDefinition from: self]	
				ifNil: [self signal: (NoNextArtifactBpmException signal: 'No next Task to execute')]].! !

!BpmParallelGateway methodsFor: 'other' stamp: 'BrunoBB 01/23/2016 13:26'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	isClosed ifTrue: [^self]. "a transition has already triggered the receiver so there is nothing to do"

	self isSplitting 
	ifTrue: [aBpmProcessInstance finalizeGateway: self.
				self evaluateOutgoingTransitionsOn: aBpmProcessInstance].

	self isMerging 
	ifTrue: [self incomingTransitionsAreDone "all path has been sychronized ?"
				ifTrue: [	isClosed := true.
							aBpmProcessInstance finalizeGateway: self.
							aBpmProcessInstance generateNextTransitionsFrom: self]
	].! !

BpmActivityInstance subclass: #BpmScriptTaskInstance
	instanceVariableNames: 'scriptVariables scriptBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 07/09/2016 14:36'!
decrementVariableNamed: varName by: decrement
	"The receiver increment the variable named <varName> by <decrement>.
	If the variable name does not exist --> is created "
	| currentValue |

	currentValue := self getValueOf: varName ifNone: [^self setVariableNamed: varName withValue: decrement negated].

	^self setVariableNamed: varName withValue: (currentValue - decrement)! !

!BpmScriptTaskInstance methodsFor: 'script' stamp: 'BrunoBB 03/05/2017 08:29'!
executeScript
	"The receiver execute the Script"
	"The script block setup in Bizagi must be:
	[:script :process | ] "

	^self getScriptBlock 
				value: self 			"aBpmScriptTaskInstance"
				value: process		"aBpmProcessInstance"! !

!BpmScriptTaskInstance methodsFor: 'script' stamp: 'BrunoBB 07/09/2016 14:31'!
getScriptBlock
	"The receiver create a new BlockClosure for the script code"

	scriptBlock ifNotNil: [^scriptBlock].

	^scriptBlock := self getScriptCode evaluate. "it create aBlock (#getScriptCode answer a String)"! !

!BpmScriptTaskInstance methodsFor: 'script' stamp: 'BrunoBB 06/21/2016 12:54'!
getScriptCode
	"The receiver get the String value of the Script"

	^definition scriptCode! !

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 06/26/2016 09:25'!
getValueOf: varName ifNone: aBlock
	"The receiver answer the value of the script variable named <varName> if the variable does not exist then evaluate the zero argument block <aBlock> "

	^scriptVariables at: varName ifAbsent: aBlock! !

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 07/02/2016 13:43'!
getValueOfFormField: varName
	"Answer the value of the variable named <varName>"

	^self getValueOf: varName ifNone: [nil]! !

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 07/02/2016 14:28'!
hasFieldNamed: aString
	"Answer whether or not the receiver has a field named <aString>"

	^scriptVariables includesKey: aString asString! !

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 06/26/2016 09:24'!
hasVariableNamed: aString
	"The receiver answer whether or not exist a script variable named <aString> "

	^scriptVariables includesKey: aString! !

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 07/09/2016 14:36'!
incrementVariableNamed: varName by: increment
	"The receiver increment the variable named <varName> by <increment>.
	If the variable name does not exist --> is created "
	| currentValue |

	currentValue := self getValueOf: varName ifNone: [^self setVariableNamed: varName withValue: increment].

	^self setVariableNamed: varName withValue: (currentValue + increment)! !

!BpmScriptTaskInstance methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 12:49'!
initialize

	super initialize.

	scriptVariables := Dictionary new.! !

!BpmScriptTaskInstance methodsFor: 'script' stamp: 'BrunoBB 06/24/2016 10:35'!
isFinished

	^scriptBlock notNil! !

!BpmScriptTaskInstance methodsFor: 'script' stamp: 'BrunoBB 06/26/2016 09:29'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	aBpmProcessInstance executeScript: self! !

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 06/26/2016 09:23'!
removeVariableNamed: varName
	"The receiver remove the script variable named <varName>"

	^scriptVariables removeKey: varName ifAbsent: []! !

!BpmScriptTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 06/22/2016 10:08'!
scriptBlock
	^scriptBlock! !

!BpmScriptTaskInstance methodsFor: 'Updating' stamp: 'BrunoBB 06/22/2016 10:08'!
scriptBlock: newValue
	scriptBlock := newValue! !

!BpmScriptTaskInstance methodsFor: 'Accessing' stamp: 'BrunoBB 06/21/2016 12:49'!
scriptVariables
	^scriptVariables! !

!BpmScriptTaskInstance methodsFor: 'Updating' stamp: 'BrunoBB 06/21/2016 12:49'!
scriptVariables: newValue
	scriptVariables := newValue! !

!BpmScriptTaskInstance methodsFor: 'script variables' stamp: 'BrunoBB 06/26/2016 09:23'!
setVariableNamed: varName withValue: anObject
	"The receiver create set a variable named <varName> with the value <anObject>"

	^scriptVariables at: varName put: anObject! !

!BpmArtifactInstance class methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:46'!
definition: aBpmArtifactDefinition

	^super new initialize
		definition: aBpmArtifactDefinition;
		yourself! !

!BpmArtifactInstance class methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:46'!
process: aBpmProcessInstance definition: aBpmArtifactDefinition

	^(self definition: aBpmArtifactDefinition)
		process: aBpmProcessInstance;
		yourself! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/16/2015 18:08'!
addIncommingTransition: aBpmTransitionInstance

	^inTransitions add: aBpmTransitionInstance! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/16/2015 18:08'!
addOutgoingTransition: aBpmTransitionInstance

	^outTransitions add: aBpmTransitionInstance! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 10:00'!
applicationName

	^definition applicationName! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 07:16'!
canCloseAndSend

	^true! !

!BpmArtifactInstance methodsFor: 'time warnings' stamp: 'BrunoBB 02/04/2017 12:57'!
countExecutionTime

	^0! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/12/2015 11:08'!
creationTime
	^creationTime! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/12/2015 11:08'!
creationTime: newValue
	creationTime := newValue! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 07/02/2016 13:22'!
defaultTransition
	"Answer the default transition.
	When out going transition have been evaluated and none passed the evaluation then 'defaultTransition' is followed"

	^definition defaultTransition! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 14:08'!
definition
	^definition! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 14:08'!
definition: newValue
	definition := newValue! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 07:35'!
endTime

	^endTime! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/07/2016 07:35'!
endTime: newValue
	endTime := newValue! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 01/23/2016 07:50'!
exceptions
	^exceptions! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 01/23/2016 07:50'!
exceptions: newValue
	exceptions := newValue! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 02/04/2017 10:59'!
expectedExecutionTime

	^nil! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 09:09'!
expectedResultValues

	^Dictionary new! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 11/07/2016 07:41'!
finalize

	state := #done.
	endTime := TimeStamp now.

	^self! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/11/2015 11:22'!
generateNextRunningTransitions
	"The receiver fetch the possibles next transitions to transition definition.
	1- Ask the path definition for next transitions.
	2- Create a concrete transtition for each definition in 1, and add it as running transitions."

	^process generateNextTransitionsFrom: self! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 10:00'!
getApplication

	^process getApplication! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 08/03/2016 14:18'!
getAssignment

	^self getProcessMatrix getAssignmentFor: self! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 13:43'!
getBasicValueOfFormField: fieldName
	"Answer the basic/string value of the field named <fieldName>"

	self subclassResponsibility! !

!BpmArtifactInstance methodsFor: 'performers' stamp: 'BrunoBB 01/17/2016 12:50'!
getCurrentPerformerIfNone: aBlock

	^aBlock value! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 13:04'!
getCurrentRoleIfNone: aBlock
	"The receiver answer the current <role> that is working now"

	^aBlock value! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 17:18'!
getDefinitionName
	"Answer the name of the receiver's artifact definition as it was defined in the Process Modeler (Bizagi)"

	^definition name! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 02/04/2017 12:15'!
getExpectedTimeWarningColor
	"The receiver answer the warning color of the execution time"

	^nil! !

!BpmArtifactInstance methodsFor: 'performers' stamp: 'BrunoBB 01/16/2016 16:03'!
getFirstPerformerIfNone: aBlock

	^definition getFirstPerformerIfNone: aBlock! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 10:02'!
getGrantedUsers
	"Answer a collection of the granted roles of the receiver"
	| grantedUsers |

	grantedUsers := OrderedCollection new.

	self getRoles do: [:each | grantedUsers addAll: each users ].

	^grantedUsers! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/12/2015 11:17'!
getInTrasitionDefinitions

	^definition inTransitions! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 09:36'!
getNextPerformerIfNone: aBlock
	"The receiver answer the next <performer> that is working now"

	^aBlock value! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 14:37'!
getNextRoleIfNone: aBlock
	"The receiver answer the current <role> that is working now"

	^aBlock value! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 07/02/2016 12:03'!
getOutTransitionDefinitions
	"The receiver answer a collection of the next transitions as defined in it's definition"

	^definition outTransitions! !

!BpmArtifactInstance methodsFor: 'performers' stamp: 'BrunoBB 01/16/2016 15:06'!
getPerformers

	^definition performers! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 08/03/2016 14:17'!
getProcessMatrix
	"The receiver answer the running tasks matrix <aBpmRunningTasksMatrix> for it's orbeon application"

	^process getProcessMatrix! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/03/2015 13:43'!
getRoles
	"Answer a collection of the granted roles of the receiver"

	^definition roles! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:55'!
getSummaryFieldsValues
	"Answer a dictionary with the values of the summary fields.
	Key (field name) >> Value (value of the field)"

	^Dictionary new! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 09:11'!
getTotalTime
	| totalTime |

	totalTime := endTime ifNil: [TimeStamp now] ifNotNil: [:value | endTime].
	
	^Time fromSeconds: (totalTime asSeconds - creationTime asSeconds)! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:46'!
getUserName

	^''! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 11:28'!
getValueOfFormField: fieldName
	"Answer the value of the field named <fieldName>"

	self subclassResponsibility! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'brunobb 10/17/2017 12:40'!
hasAttachedEvents

	^definition hasAttachedEvents! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 02/04/2017 10:59'!
hasExpectedExecutionTime

	^false! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 12:21'!
hasFieldNamed: aSymbol
	"Answer whether or not the receiver has a field named <aSymbol>"

	^false! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 09:32'!
hasForm

	^false! !

!BpmArtifactInstance methodsFor: 'performers' stamp: 'BrunoBB 04/13/2016 10:16'!
hasPerformers
	"Answer whether or not the receiver has performers.
	Regular task consist in one form or one Seaside Component.
	Task with performers enable to more than one role work in the same task (in sequential way)"

	^definition hasPerformers! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 14:08'!
id
	^id! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 14:08'!
id: newValue
	id := newValue! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'brunobb 09/04/2017 05:24'!
initialize

	super initialize.

	id := Lag1MwcRandom new integer.
	creationTime := TimeStamp now.
	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.
	state := #created. "#created #processing #paused #pending #delayed #done"
	exceptions := OrderedCollection new.! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 12:57'!
inTransitions
	^inTransitions! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/01/2015 12:57'!
inTransitions: newValue
	inTransitions := newValue! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/11/2015 08:57'!
isCreated

	^state = #created! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/11/2015 08:57'!
isDelayed

	^state = #delayed! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'brunobb 11/02/2017 13:25'!
isDone
	"The receiver answer whether or not it'has been finalized"

	^state = #done! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 11/29/2015 15:11'!
isEndEvent

	^definition isEndEvent! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 13:23'!
isFinishedByPerformers
	"Answer whether or not in the receiver has worked all defined <performers>, only then the receiver can be close and send"

	^true! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 03/30/2016 17:05'!
isGrantedUser: aBpmUser
	"Answer whether or not the user <aBpmUser> is granted in the receiver.
	If the process has been created by an anonymous user then everyone has read access"

	^process startEventIsAnonymous or: [definition isGrantedUser: aBpmUser]! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/28/2015 09:47'!
isMultiInstance

	^definition isMultiInstance! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 02/04/2017 12:33'!
isOverdue

	^false! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/11/2015 08:57'!
isPaused

	^state = #paused! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/11/2015 08:58'!
isPending

	^state = #pending! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/11/2015 08:58'!
isProcessing

	^state = #processing! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 12/11/2015 06:57'!
isSubprocess

	^definition isSubprocessDefinition! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 07/31/2016 13:27'!
isTask

	^false! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'brunobb 10/28/2017 15:38'!
isTimerEvent

	^false! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 12:57'!
outTransitions
	^outTransitions! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/01/2015 12:57'!
outTransitions: newValue
	outTransitions := newValue! !

!BpmArtifactInstance methodsFor: 'process execution' stamp: 'BrunoBB 11/16/2015 17:33'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 11:43'!
previousFieldValues
	"Answer aDictionary where the keys are the names of the fields of the Previous(parent) Transition, and the values are the values of each field in the previous transition"

	^Dictionary new! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:35'!
printFormLargeNameForWebButton

	^(process indexOfTransition: self) printString, '. ', self getDefinitionName capitalized.! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 14:42'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ' (', self printOnType, ') [', self getDefinitionName, ']'.! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 07/09/2016 14:38'!
printOnType

	definition ifNil: [^'def: nil'].

	^definition printOnType! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:03'!
printRoleNames

	^definition printRoleNames! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 09:00'!
printState

	state ifNil: [^'-'].

	^state! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 14:08'!
process
	^process! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 14:08'!
process: newValue
	process := newValue! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 10:30'!
processDefinition

	^process definition! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 11:12'!
processId

	^process id! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 01/18/2016 09:38'!
removeLastWorker! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 09:28'!
serviceIds

	^Dictionary new! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 01/23/2016 07:51'!
signal: aBpmException
	"The receiver add the exception <aBpmException> to the collection <exceptions>"

	^exceptions add: aBpmException! !

!BpmArtifactInstance methodsFor: 'Accessing' stamp: 'BrunoBB 01/23/2016 07:34'!
state
	^state! !

!BpmArtifactInstance methodsFor: 'Updating' stamp: 'BrunoBB 01/23/2016 07:34'!
state: newValue
	state := newValue! !

!BpmArtifactInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:52'!
summaryTitle

	^self subclassResponsibility! !

BpmArtifactInstance subclass: #BpmEventInstance
	instanceVariableNames: 'trigger attachedTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmEventInstance subclass: #BpmEndEventInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmEndEventInstance methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:03'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	aBpmProcessInstance finalizeWith: self! !

!BpmEventInstance methodsFor: 'Accessing' stamp: 'brunobb 10/18/2017 13:02'!
attachedTask
	^attachedTask! !

!BpmEventInstance methodsFor: 'Updating' stamp: 'brunobb 10/18/2017 13:02'!
attachedTask: newValue
	attachedTask := newValue! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'brunobb 11/03/2017 05:15'!
finalize

	super finalize.

	self isTimerEvent ifFalse: [^self].

	self defaultTimerEventMonitor stopMonitoringArtifact: self.

	"<attachedTask finalize> is NOT used because it will cause an infinit loop. 
	The task will attempt to finalize the attached event again and the attached event will attempt to fnalize the task and ...."
	(self isAttachedEvent and: [self isInterrupting]) 
	ifTrue: [attachedTask finalizeWithoutAttachedEvents].! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'brunobb 11/02/2017 07:48'!
generateNextRunningTransitions
	"The receiver fetch the possibles next transitions to transition definition.
	1- Ask the path definition for next transitions.
	2- Create a concrete transtition for each definition in 1, and add it as running transitions."

	super generateNextRunningTransitions.

	"if the receiver is independent then is finalized. if the receiver is attached to <aBpmTask> then is the task that send the #finalize to the event"
	self isAttachedEvent ifFalse: [self finalize].! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'brunobb 10/24/2017 14:51'!
getTimerBlock

	^definition getTimerBlock! !

!BpmEventInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 07:39'!
initialize

	super initialize.

	endTime := TimeStamp now.! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'BrunoBB 03/30/2016 16:43'!
isAnonymousEvent
	"Answer whether or not the receiver has been started by an anonymous trigger"

	^trigger isNil! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'brunobb 10/20/2017 12:42'!
isAttachedEvent

	^attachedTask notNil! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'brunobb 10/20/2017 12:59'!
isInterrupting

	^definition isInterrupting! !

!BpmEventInstance methodsFor: 'other' stamp: 'brunobb 10/28/2017 15:38'!
isTimerEvent

	^definition isTimerEvent! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'brunobb 10/29/2017 14:41'!
performInitializationOn: aBpmProcessInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	aBpmProcessInstance addEvent: self.

	self isTimerEvent ifFalse: [^self].

	"attached event were already put on <BpmTimerEventMonitor> when the parent <BpmTaskInstance> was created"
	self isAttachedEvent ifTrue: [^self].

	"the receiver is an independent timer (no attached to any task) so it is added to the <BpmTimerEventMonitor>"
	self defaultTimerEventMonitor startMonitoringArtifact: self.! !

!BpmEventInstance methodsFor: 'process execution' stamp: 'brunobb 10/25/2017 07:21'!
performInitializationOn: aBpmProcessInstance attachTo: aBpmTaskInstance
	"The receiver perform the creation operation in the process instance <aBpmProcessInstance>.
	This operatoin initialize the receiver inside the process <aBpmProcessInstance>"

	aBpmTaskInstance attachEvent: self. 

	^self performInitializationOn: aBpmProcessInstance! !

!BpmEventInstance methodsFor: 'Accessing' stamp: 'BrunoBB 03/30/2016 16:42'!
trigger
	^trigger! !

!BpmEventInstance methodsFor: 'Updating' stamp: 'BrunoBB 03/30/2016 16:42'!
trigger: newValue
	trigger := newValue! !

BpmEventInstance subclass: #BpmIntermediateEventInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmEventInstance subclass: #BpmStartEventInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmObject subclass: #BpmAssignmentFinalization
	instanceVariableNames: 'assignment nextTransitions isFinalized user assignNextToUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmAssignmentFinalization class methodsFor: 'other' stamp: 'BrunoBB 07/25/2016 09:28'!
on: aBpmTaskAssignment by: aBpmUser

	^super new initialize
		user: aBpmUser;
		assignment: aBpmTaskAssignment;
		yourself! !

!BpmAssignmentFinalization methodsFor: 'Accessing' stamp: 'BrunoBB 07/25/2016 09:22'!
assignment
	^assignment! !

!BpmAssignmentFinalization methodsFor: 'Updating' stamp: 'BrunoBB 07/25/2016 09:22'!
assignment: newValue
	assignment := newValue! !

!BpmAssignmentFinalization methodsFor: 'Accessing' stamp: 'BrunoBB 07/25/2016 10:15'!
assignNextToUser
	^assignNextToUser! !

!BpmAssignmentFinalization methodsFor: 'Updating' stamp: 'BrunoBB 07/25/2016 10:15'!
assignNextToUser: newValue
	assignNextToUser := newValue! !

!BpmAssignmentFinalization methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 14:39'!
finalizeAssignment
	"The receiver finalize it's assignment <aBpmTaskAssignment> and the finalizer is the <BpmUser> <user>"
	| finishedMatrix currentActivities |

	assignment finalize. "move the <task> of the <assignment> from process <currentActivities> to process <executedActivities>"
	isFinalized := true.

	user moveFromCurrentToFinished: assignment. "<user> move from current assignments to finished <assignment> "

	"add the assignment to finished matrix"
	finishedMatrix := self getFinishedMatrixManagerClass getMatrixForApplicationNamed: assignment applicationName.
	finishedMatrix addAssignment: assignment.

	"generate next transitions and put New Tasks in the Application Running Matrix"
	currentActivities := OrderedCollection withAll: self process currentActivities.
	nextTransitions := assignment generateNextRunningTransitions. 

	"ifTrue: the same user <user> that finished the task is going to take next generated tasks"
	assignNextToUser ifTrue: [ | assignments availableAssignments newActivities |
		availableAssignments := user getAllAvailableTaskAssignments.
		newActivities := self process currentActivities asArray removeAll: currentActivities; yourself.
		assignments := newActivities collect: [:each | self getProcessMatrix getAssignmentFor: each].
		(assignments select: [:eachAssign | eachAssign notNil and: [availableAssignments includes: eachAssign]]) 
			do:[:each | user take: each].
		].! !

!BpmAssignmentFinalization methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 14:12'!
getNewCreatedTasks

	^nextTransitions collect: [:each | each endArtifact] thenSelect: [:each | each isTask]! !

!BpmAssignmentFinalization methodsFor: 'other' stamp: 'BrunoBB 07/31/2016 13:43'!
getProcessMatrix

	^self process getProcessMatrix! !

!BpmAssignmentFinalization methodsFor: 'other' stamp: 'BrunoBB 07/25/2016 10:15'!
initialize

	super initialize.

	nextTransitions := OrderedCollection new.
	isFinalized := false.
	assignNextToUser := false! !

!BpmAssignmentFinalization methodsFor: 'Accessing' stamp: 'BrunoBB 07/25/2016 09:22'!
isFinalized
	^isFinalized! !

!BpmAssignmentFinalization methodsFor: 'Updating' stamp: 'BrunoBB 07/25/2016 09:22'!
isFinalized: newValue
	isFinalized := newValue! !

!BpmAssignmentFinalization methodsFor: 'Accessing' stamp: 'BrunoBB 07/25/2016 09:22'!
nextTransitions
	^nextTransitions! !

!BpmAssignmentFinalization methodsFor: 'Updating' stamp: 'BrunoBB 07/25/2016 09:22'!
nextTransitions: newValue
	nextTransitions := newValue! !

!BpmAssignmentFinalization methodsFor: 'other' stamp: 'BrunoBB 07/31/2016 13:40'!
process

	^assignment process! !

!BpmAssignmentFinalization methodsFor: 'other' stamp: 'BrunoBB 07/25/2016 10:27'!
setUserToTakeNextTasks
	"The receive set the BpmUser <user> to take all generated tasks"

	assignNextToUser := true! !

!BpmAssignmentFinalization methodsFor: 'Accessing' stamp: 'BrunoBB 07/25/2016 09:28'!
user
	^user! !

!BpmAssignmentFinalization methodsFor: 'Updating' stamp: 'BrunoBB 07/25/2016 09:28'!
user: newValue
	user := newValue! !

BpmObject subclass: #BpmCodeEvaluationResult
	instanceVariableNames: 'result exception conditionString'
	classVariableNames: 'FailedEvalCache'
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmCodeEvaluationResult class methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 10:29'!
exception: anException

	^super new initialize
		exception: anException;
		result: false;
		yourself! !

!BpmCodeEvaluationResult class methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 11:23'!
failedEvaluationCache

	FailedEvalCache ifNil: [FailedEvalCache := OrderedCollection new].

	^FailedEvalCache! !

!BpmCodeEvaluationResult class methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 10:29'!
result: aBoolean

	^super new initialize
		result: aBoolean;
		yourself! !

!BpmCodeEvaluationResult methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 12:19'!
addToCache

	^self class failedEvaluationCache add: self! !

!BpmCodeEvaluationResult methodsFor: 'Accessing' stamp: 'BrunoBB 11/25/2015 10:28'!
exception
	^exception! !

!BpmCodeEvaluationResult methodsFor: 'Updating' stamp: 'BrunoBB 11/25/2015 10:39'!
exception: newValue
   "Modify the value of the instance variable 'exception'."

	exception := newValue.
	result := false.! !

!BpmCodeEvaluationResult methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 10:29'!
hasException

	^exception notNil! !

!BpmCodeEvaluationResult methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 10:29'!
hasNoException

	^exception isNil! !

!BpmCodeEvaluationResult methodsFor: 'Accessing' stamp: 'BrunoBB 11/25/2015 10:28'!
result
	^result! !

!BpmCodeEvaluationResult methodsFor: 'Updating' stamp: 'BrunoBB 11/25/2015 10:28'!
result: newValue
	result := newValue! !

!BpmCodeEvaluationResult methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 10:30'!
resultNotBoolean

	^(result isKindOf: Boolean) not! !

BpmObject subclass: #BpmCodeFailedEvaluation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmObject subclass: #BpmCodePostExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmCodePostExecution subclass: #BpmCodeNonePostExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmObject subclass: #BpmNotification
	instanceVariableNames: 'timeStamp title notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmNotification methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 10:43'!
initialize

	super initialize.

	timeStamp := TimeStamp now.
	title := ''.
	notification := ''.! !

!BpmNotification methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 10:42'!
notification
	^notification! !

!BpmNotification methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 10:42'!
notification: newValue
	notification := newValue! !

!BpmNotification methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 10:42'!
timeStamp
	^timeStamp! !

!BpmNotification methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 10:42'!
timeStamp: newValue
	timeStamp := newValue! !

!BpmNotification methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 10:42'!
title
	^title! !

!BpmNotification methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 10:42'!
title: newValue
	title := newValue! !

BpmNotification subclass: #BpmSystemNotification
	instanceVariableNames: 'senderModule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmSystemNotification class methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 10:50'!
fromModule: moduleName

	^super new initialize
		senderModule: moduleName;
		yourself! !

!BpmSystemNotification methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 10:47'!
senderModule
	^senderModule! !

!BpmSystemNotification methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 10:47'!
senderModule: newValue
	senderModule := newValue! !

BpmNotification subclass: #BpmUserNotification
	instanceVariableNames: 'senderUser receivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmUserNotification class methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 10:49'!
fromUser: aBpmUser

	^super new initialize
		senderUser: aBpmUser;
		yourself! !

!BpmUserNotification methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 10:48'!
addReceiver: aBpmUser

	^receivers add: aBpmUser! !

!BpmUserNotification methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 10:47'!
initialize

	super initialize.

	receivers := OrderedCollection new.! !

!BpmUserNotification methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 10:49'!
receivers
	^receivers! !

!BpmUserNotification methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 10:49'!
receivers: newValue
	receivers := newValue! !

!BpmUserNotification methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 10:48'!
removeReceiver: aBpmUser

	^receivers remove: aBpmUser ifAbsent: []! !

!BpmUserNotification methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 10:49'!
senderUser
	^senderUser! !

!BpmUserNotification methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 10:49'!
senderUser: newValue
	senderUser := newValue! !

!BpmObject methodsFor: '*orbeonBPMRuntime' stamp: 'BrunoBB 12/26/2015 14:14'!
getFinishedMatrixManagerClass

	^BpmFinishedTasksMatrix! !

!BpmObject methodsFor: '*orbeonBPMRuntime' stamp: 'BrunoBB 12/05/2015 13:49'!
getMatrixManagerClass

	^BpmRunningTasksMatrix! !

BpmObject subclass: #BpmProcessCategory
	instanceVariableNames: 'name processes color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmProcessCategory class
	instanceVariableNames: 'cache'!

!BpmProcessCategory class methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:19'!
cache

	cache ifNil: [self initializeCache].

	^cache! !

!BpmProcessCategory class methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:17'!
getCategoriesFor: aBpmUser

	^self getCategoriesForUserNamed: aBpmUser username! !

!BpmProcessCategory class methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:20'!
getCategoriesForUserNamed: aString

	^(self cache at: aString ifAbsent: [^OrderedCollection new])
			asSortedCollection: [:a :b | a name <= b name]! !

!BpmProcessCategory class methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:20'!
getCategory: categoryName forUserNamed: aString

	^(self getCategoriesForUserNamed: aString) detect: [:each | each name = categoryName] ifNone: [^nil]! !

!BpmProcessCategory class methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:20'!
initializeCache

	cache := Dictionary new.

	^cache! !

!BpmProcessCategory class methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 12:04'!
resetAll

	self cache do: [:userDictionary | 
		userDictionary do: [:category | category resetAll]]! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 11:31'!
add: aBpmProcessInstance

	^processes add: aBpmProcessInstance! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 11:33'!
addToCacheIn: username
	| userCache |

	name ifNil: [^CategoryWithNoNameException signal]. 
	username ifNil: [^CategoryWithNoNameException signal].
	name isEmpty ifTrue: [^CategoryWithNoNameException signal].	
	username isEmpty ifTrue: [^CategoryWithNoNameException signal].

	userCache := self class cache at: username ifAbsentPut: [Dictionary new].

	^userCache at: name put: self! !

!BpmProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 11:30'!
color
	^color! !

!BpmProcessCategory methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 11:30'!
color: newValue
	color := newValue! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 11:32'!
currentProcesses

	^processes reject: [:each | each hasFinalized]! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 11:32'!
finishedProcesses

	^processes select: [:each | each hasFinalized]! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 11:31'!
includes: aBpmProcessInstance

	^processes includes: aBpmProcessInstance! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 06:19'!
initialize

	super initialize.

	name := ''.
	processes := OrderedCollection new.! !

!BpmProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 11:30'!
name
	^name! !

!BpmProcessCategory methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 11:30'!
name: newValue
	name := newValue! !

!BpmProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 11:30'!
processes
	^processes! !

!BpmProcessCategory methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 11:30'!
processes: newValue
	processes := newValue! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 11:31'!
remove: aBpmProcessInstance

	^processes remove: aBpmProcessInstance ifAbsent: []! !

!BpmProcessCategory methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:32'!
removeFromCacheFrom: username
	| userCache |

	name ifNil: [^CategoryWithNoNameException signal]. 
	username ifNil: [^CategoryWithNoNameException signal].
	name isEmpty ifTrue: [^CategoryWithNoNameException signal].	
	username isEmpty ifTrue: [^CategoryWithNoNameException signal].

	userCache := self class cache at: username ifAbsent: [^AppObjectNotInCacheException signal].

	^userCache removeKey: name ifAbsent: [^AppObjectNotInCacheException signal]! !

!BpmProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 12/14/2015 11:56'!
resetAll

	processes := OrderedCollection new.! !

BpmProcessCategory subclass: #BpmProcessDefinitionCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmProcessCategory subclass: #BpmProcessDynamicCategory
	instanceVariableNames: 'selectMethod selectorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmProcessCategory subclass: #BpmProcessInstanceCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmObject subclass: #BpmProcessInstance
	instanceVariableNames: 'definition id processName currentActivities executedActivities transitions subprocesses creator createdTime postExecution startEvent endEvents runningGateways executedGateways userAssignments executedScripts intermediateEvents states externalVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmProcessInstance class methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:57'!
definition: aBpmProcessDefinition

	^self definition: aBpmProcessDefinition user: nil! !

!BpmProcessInstance class methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:16'!
definition: aBpmProcessDefinition user: aBpmUser

	^super new initialize
		definition: aBpmProcessDefinition;
		creator: aBpmUser;
		processName: aBpmProcessDefinition processName;
		yourself! !

!BpmProcessInstance class methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 11:55'!
resetAll

	BpmUser resetAll. "remove user's assignments"

	BpmRunningTasksMatrix resetAll. "remove all assignments from the matrix"

	BpmProcessDefinition removeAllFormFieldInstances.

	BpmProcessInstanceCategory resetAll.! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:28'!
abortProcess: aBpmUser
	"The receiver switch the <state> to <aborted>"

	^states add: (BpmAbortedState newFor: self user: aBpmUser)! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 10/24/2017 11:57'!
addActivityToPerform: aBpmTaskInstance
	"Add the task <aBpmTaskInstance> to be performed and finished by the receiver"

	currentActivities add: aBpmTaskInstance.

	^self getProcessMatrix addTask: aBpmTaskInstance. "from <aBpmTaskInstance> create the assignment <BpmTaskAssignment>"! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 10/29/2017 15:02'!
addEvent: aBpmEventInstance
	"The receiver add <aBpmEventInstance> to it's event collection"

	^intermediateEvents 
		at: aBpmEventInstance getDefinitionName  
		ifPresent: [:collection | collection add: aBpmEventInstance]
		ifAbsent: [intermediateEvents at: aBpmEventInstance getDefinitionName put: (OrderedCollection with: aBpmEventInstance)]! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 12/01/2015 12:01'!
addSubProcess: aBpmSubProcessInstance
	"The receiver add the subprocess <aBpmSubProcessInstance> to it's sub process collection. Set the receiver as the parent process of the process argument <aBpmSubProcessInstance>"

	aBpmSubProcessInstance parentProcess: self.

	^subprocesses add: aBpmSubProcessInstance! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/31/2017 10:31'!
addToAbortedProcess
	"The receiver is add to aborted process collection of its definition <aBpmProcessDefinition>"

	^definition addAbortedProcess: self! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:32'!
applicationName

	^self getApplication applicationName! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:16'!
assignedUserNames

	^'******'! !

!BpmProcessInstance methodsFor: 'xpdl' stamp: 'BrunoBB 09/13/2016 09:46'!
changeColorOfGatewaysOf: transitionsNodes in: xmlDocument for: aBpmUser

	transitionsNodes do: [:eachNode | | nodeId trNode |
		nodeId := eachNode attributeAt: 'To'.
		trNode := ((xmlDocument allElementsNamed: 'Activity') select: [:each | (each findElementNamed: 'Route') notNil])
							detect: [:each | (each attributeAt: 'Id') = nodeId] ifNone: [nil].
		trNode notNil
		ifTrue: [(trNode findElementNamed: 'NodeGraphicsInfo') 
						attributeAt: 'FillColor' 
						put: (aBpmUser getProperty: 'bizagi.gateway.fillColor.done').].
	]! !

!BpmProcessInstance methodsFor: 'xpdl' stamp: 'BrunoBB 09/13/2016 09:46'!
changeColorOfTransitionsReaching: executedNodes in: xmlDocument for: aBpmUser
	| transitionNodes |

	transitionNodes := OrderedCollection new.
	executedNodes do: [:eachNode | | nodeId nodeName trNode |
		nodeId := eachNode attributeAt: 'Id'.
		nodeName := eachNode attributeAt: 'Name'.
		trNode := (xmlDocument allElementsNamed: 'Transition') detect: [:each | (each attributeAt: 'To') = nodeId] ifNone: [nil].
		trNode notNil
		ifTrue: [(trNode findElementNamed: 'ConnectorGraphicsInfo') 
						attributeAt: 'BorderColor' 
						put: (aBpmUser getProperty: 'bizagi.transition.borderColor.done').
			transitionNodes add: trNode].

		trNode := (xmlDocument allElementsNamed: 'Transition') detect: [:each | (each attributeAt: 'From') = nodeId] ifNone: [nil].
		(trNode notNil and:[executedActivities anySatisfy: [:each | each getDefinitionName = nodeName]])
		ifTrue: [(trNode findElementNamed: 'ConnectorGraphicsInfo') 
						attributeAt: 'BorderColor' 
						put: (aBpmUser getProperty: 'bizagi.transition.borderColor.done').
			transitionNodes add: trNode].
	].

	^transitionNodes! !

!BpmProcessInstance methodsFor: 'xpdl' stamp: 'BrunoBB 04/15/2016 11:20'!
changeColorTo: xmlNode fillColor: fillColorIndex borderColor: borderColorIndex

	(xmlNode findElementNamed: 'NodeGraphicsInfo') attributeAt: 'FillColor' put: fillColorIndex.
	(xmlNode findElementNamed: 'NodeGraphicsInfo') attributeAt: 'BorderColor' put: borderColorIndex.! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 01/04/2018 11:20'!
confirmAbortion
	"The receiver confirm the abortion state <BpmAbortedState>.
	Be careful because ALL processes Tree is aborted"
	| subProcToAbort |

	self currentState isConfirmed: true. 
	self currentState confirmAbortion.

	"here we proceed to abort all sub process"
	subProcToAbort := self getProcessesTreeAsCollection.
	subProcToAbort remove: self. "the tree collection includes the receiver that already has been aborted"

	subProcToAbort do: [:procInst | 
		procInst abortProcess: nil. 
		procInst currentState isConfirmed: true.
		procInst currentState confirmAbortion.
	]! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
createdTime
	^createdTime! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
createdTime: newValue
	createdTime := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/29/2015 16:16'!
createNewTransition: aBpmTransitionDefinition from: aBpmArtifactInstance
	"The receiver creates a new concrete transition based on the definition <aBpmTransitionDefinition> and this transition has been started from the artifact <aBpmArtifactInstance>"
	| newTransition endArtifact |

	newTransition := BpmTransitionInstance definition: aBpmTransitionDefinition.
	"create the end artifact of the new transition"
	endArtifact := aBpmTransitionDefinition endArtifact createInstanceOn: self.

	newTransition startArtifact: aBpmArtifactInstance; "also add <newTransition> as an outgoing transition to <aBpmArtifactInstance>"
		endArtifact: endArtifact. "also add <newTransition> as an incomming transition to <endArtifact>"

	transitions add: newTransition.

	endArtifact performInitializationOn: self. "the artifact is initialized"

	^newTransition! !

!BpmProcessInstance methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 13:09'!
createZipFileWithName: pathFile for: aBpmUser
	| file archive | 

	archive := ZipArchive new.

	file := GsFile open: pathFile mode: 'wb' onClient: false.

	self storeOnZip: archive withFile: file for: aBpmUser.

	file close.! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
creator
	^creator! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
creator: newValue
	creator := newValue! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:04'!
creatorName

	creator ifNil: [^''].

	^creator username! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
currentActivities
	^currentActivities! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
currentActivities: newValue
	currentActivities := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:08'!
currentState
	"The receiver answer it's current state.
	Also the receiver is create by default with <BpmRunningState>"

	^states last! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
definition
	^definition! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
definition: newValue
	definition := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/12/2016 07:59'!
doesNotUnderstand: aMessageDescriptor
	"The receiver overide this method in order to respond to messages that are equal in name to any of it's field name"

	(executedActivities, executedScripts)
		detect: [:each | each hasFieldNamed: aMessageDescriptor selector asString] "check the variable name in the process instance"
		ifNone: [^(self hasFieldNamed: aMessageDescriptor selector asString) "check the variable name in the process definition"
					ifTrue: [nil] "the <variable name> exist but is not initialized --> nil"
					ifFalse: [super doesNotUnderstand: aMessageDescriptor] "if not --> default doesNotUnderstand:"
					].

	^self getValueOfProcessField: aMessageDescriptor selector asString! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 03/29/2016 09:55'!
endEvents
	^endEvents! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 03/29/2016 09:55'!
endEvents: newValue
	endEvents := newValue! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
executedActivities
	^executedActivities! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
executedActivities: newValue
	executedActivities := newValue! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
executedGateways
	^executedGateways! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
executedGateways: newValue
	executedGateways := newValue! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 06/24/2016 10:24'!
executedScripts
	^executedScripts! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 06/24/2016 10:24'!
executedScripts: newValue
	executedScripts := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 06/24/2016 10:42'!
executeScript: aBpmScriptTaskInstance
	"The receiver execute the BPM Script <aBpmScriptTaskInstance>"

	aBpmScriptTaskInstance executeScript.

	executedScripts add: aBpmScriptTaskInstance.

	self generateNextTransitionsFrom: aBpmScriptTaskInstance.! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'brunobb 12/27/2017 10:22'!
externalVariables
	^externalVariables! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'brunobb 12/27/2017 10:22'!
externalVariables: newValue
	externalVariables := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/29/2015 16:16'!
finalizeGateway: aBpmGatewayInstance
	"The receiver finalize the execution of <aBpmGatewayInstance>.
	Remove the gateway from running gateways dictionary and add it to the executed gateways collection"

	self removeRunningGatewayNamed: aBpmGatewayInstance getDefinitionName.

	executedGateways add: aBpmGatewayInstance! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 12/01/2015 12:03'!
finalizeWith: aBpmEndEventInstance
	"The receiver is finalized with the end event <aBpmEndEventInstance>"

	^endEvents at: aBpmEndEventInstance getDefinitionName put: aBpmEndEventInstance! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 01/12/2018 13:00'!
generateNextTransitionsFrom: aBpmTaskInstance
	"The receiver generate the next tasks to be performed from the finalized task <aBpmTaskInstance>"
	| nextTransitions |

	self isRunning ifFalse: [^ProcessNotRunningException signal: 'No new transitions can be created because the process is NOT [running]']. "if the receiver is NOT running then no new transitions are created"

	"each transition can have a condition or not. 
	a transition is selected --> if has NO condition or the condition answer <true> after evaluation"
	nextTransitions := aBpmTaskInstance getOutTransitionDefinitions select: [:trDefinition | trDefinition hasCondition not or: [trDefinition evaluateConditionIn: self]].

	"after the selection of <BpmTransitionDefinition> the concrete transations are created <BpmTransitionInstance>"
	nextTransitions do: [:transitionDefinition | self createNewTransition: transitionDefinition from: aBpmTaskInstance].! !

!BpmProcessInstance methodsFor: 'xpdl' stamp: 'BrunoBB 09/13/2016 09:46'!
generateProcessMapFor: aBpmUser
	"The receiver generate an XML String which is a XPLD file.
	This file must be imported as XPDL in Bizagi and it shows the execution path of the receiver.
	Map executed transitions with XML nodes"
	| xmlDocument executedNodes transitionsNodes |

	xmlDocument := XMLDOMParser parse: definition xmlString.

	executedNodes := OrderedCollection new.
	(executedActivities select: [:each | each isTask and:[each isDone]]) do: [:eachArt | | node |
		node := (xmlDocument allElementsNamed: 'Activity') detect: [:each | (each attributeAt: 'Name') = eachArt getDefinitionName].
		executedNodes add: node.
		self changeColorTo: node fillColor: (aBpmUser getProperty: 'bizagi.task.fillColor.done') borderColor: (aBpmUser getProperty: 'bizagi.task.borderColor.done')].

	(currentActivities select: [:each | each isTask]) do: [:eachArt | | node |
		node := (xmlDocument allElementsNamed: 'Activity') detect: [:each | (each attributeAt: 'Name') = eachArt getDefinitionName].
		executedNodes add: node.
		self changeColorTo: node fillColor: (aBpmUser getProperty: 'bizagi.task.fillColor.pending') borderColor: (aBpmUser getProperty: 'bizagi.task.borderColor.pending')].

	(subprocesses select: [:each | each hasFinalized]) do: [:eachProc | | node |
		node := (xmlDocument allElementsNamed: 'Activity') detect: [:each | (each attributeAt: 'Name') = eachProc getDefinitionName].
		executedNodes add: node.
		self changeColorTo: node fillColor: (aBpmUser getProperty: 'bizagi.subprocess.fillColor.done') borderColor: (aBpmUser getProperty: 'bizagi.subprocess.borderColor.done')].

	transitionsNodes := self changeColorOfTransitionsReaching: executedNodes in: xmlDocument for: aBpmUser.

	self changeColorOfGatewaysOf: transitionsNodes in: xmlDocument for: aBpmUser.

	^xmlDocument! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/29/2015 16:16'!
getActiveArtifacts
	"The receiver answer a collection with the current active artifacts"

	^currentActivities! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 08:27'!
getAllArtifacts

	^currentActivities, executedActivities! !

!BpmProcessInstance methodsFor: 'other' stamp: 'brunobb 12/27/2017 09:11'!
getAllRoles
	"Answer a collection with all <BpmRole> that perform at least one task in the receiver"

	^definition getAllRoles! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:41'!
getApplication

	^definition application! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 10:03'!
getApplicationName

	^definition getApplicationName! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 04/15/2016 11:42'!
getBasicValueOfProcessField: fieldName
	"Answer the first value of a field named <fieldName> in the receiver's collection of <executedActivities>.
	The search is performed only in activities that have anOrbeonFormInstance <hasForm>."
	| treeCollection |

	(executedActivities reverse select: [:each | each hasForm]) 
		do: [:each | (each getBasicValueOfFormField: fieldName) ifNotNil: [:value | ^value]].

	"searching the value in sub and parent processes"
	treeCollection := self getProcessesTreeAsCollection remove: self; yourself. "to avoid stack overflow"

	^(treeCollection detect: [:proc | (proc getBasicValueOfProcessField: fieldName) notNil] ifNone: [nil])
		ifNil: [nil] 
		ifNotNil: [:proc | proc getBasicValueOfProcessField: fieldName]

	"#reverse is used because the process can be recursive (can be more than one field value for a given field name) --> we check for the lastest executed transitions"! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 08:14'!
getColorForActivityNamed: aString

	(currentActivities anySatisfy: [:each | each getDefinitionName = aString]) ifTrue: [^'lightblue'].

	(executedActivities anySatisfy: [:each | each getDefinitionName = aString]) ifTrue: [^'lightgreen'].

	(runningGateways anySatisfy: [:each | each getDefinitionName = aString]) ifTrue: [^'lightblue'].

	(executedGateways anySatisfy: [:each | each getDefinitionName = aString]) ifTrue: [^'lightgreen'].

	^'lightgray'! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 10:01'!
getColorForActivityNamed: aString user: aBpmUser

	(currentActivities anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.fillColor.running'].

	(executedActivities anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.fillColor.done'].

	(runningGateways anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.fillColor.running'].

	(executedGateways anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.fillColor.done'].

	^'lightgray'! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 09:51'!
getColorForTransition: xpdlTransitionNode user: aBpmUser

	^(transitions anySatisfy: [:each | each startArtifactName = xpdlTransitionNode startNodeName and: [each endArtifactName = xpdlTransitionNode endNodeName]]) 
		ifTrue: [aBpmUser getProperty: 'svg.transition.borderColor.done'] 
		ifFalse: [aBpmUser getProperty: 'svg.transition.borderColor.pending']! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:11'!
getContextApplications

	^self subclassResponsibility! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:16'!
getDefinitionName

	^definition processName! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 11/02/2017 12:35'!
getEventsNamed: aString ifNone: aBlock
	"The receiver answer a collection of <aBpmEventInstance> named <aString> if there is none event with that name evaluate zero argument block <aBlock>"

	^intermediateEvents at: aString ifAbsent: aBlock! !

!BpmProcessInstance methodsFor: 'other' stamp: 'brunobb 10/17/2017 14:01'!
getExecutedActivityNamed: aString ifNone: aBlock
	"Answer the executed activity named <aString> if none evaluate the zero argument block <aBlock>.
	The #reverse is used because the activity could be executed more than two times --> the last in the collection must be reached first (is the last execution)."

	^self getExecutedArtifacts reverse detect: [:each | each getDefinitionName = aString] ifNone: aBlock! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:23'!
getExecutedArtifacts

	^executedActivities! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 06/24/2016 10:53'!
getExecutedScriptNamed: aString ifNone: aBlock

	^executedScripts detect: [:each | each getDefinitionName = aString] ifNone: [^aBlock value]! !

!BpmProcessInstance methodsFor: 'other' stamp: 'brunobb 12/31/2017 12:26'!
getFinishedProcessMatrix
	"The receiver answer the running tasks matrix <aBpmRunningTasksMatrix> for it's orbeon application"

	^self getFinishedMatrixManagerClass getMatrixForApplicationNamed: self applicationName! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 10/24/2017 14:31'!
getLastEventNamed: aString ifNone: aBlock
	"The receiver answer the last <aBpmEventInstance> named <aString> if there is none event with that name evaluate zero argument block <aBlock>"

	(intermediateEvents includesKey: aString) ifFalse: [^aBlock value].

	^(intermediateEvents at: aString) 
		ifNotEmpty: [:collection | collection last]
		ifEmpty: aBlock! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 03/23/2016 14:32'!
getProcessesTreeAsCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	^self getProcessTree: OrderedCollection new! !

!BpmProcessInstance methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 13:06'!
getProcessMapStreamFor: aBpmUser

	^definition hasSubProcesses
		ifTrue: [self getZipProcessMapStreamFor: aBpmUser] "generate a ZIP with all subprocesses"
		ifFalse: [self getSingleProcessMapStreamFor: aBpmUser]. "generate a XPDL"! !

!BpmProcessInstance methodsFor: 'other' stamp: 'brunobb 12/31/2017 12:26'!
getProcessMatrix
	"The receiver answer the running tasks matrix <aBpmRunningTasksMatrix> for it's orbeon application"

	^self getMatrixManagerClass getMatrixForApplicationNamed: self applicationName! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 03/23/2016 14:27'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	self subclassResponsibility! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:24'!
getRunningArtifacts

	^currentActivities! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:16'!
getRunningGatewayNamed: aString
	"Answer the running gateway named <aString> if none the answer <nil>"

	^runningGateways at: aString ifAbsent: [nil]! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 06/24/2016 10:58'!
getScriptVariableNamed: aString ifNone: aBlock
	"Answer the first variable named (in ALL script) that has a variable named <aString> if there is none evaluate the zero arg block <aBlock>"
	| script |

	script := executedScripts detect: [:each | each hasVariableNamed: aString] ifNone: [^nil].

	^script getValueOf: aString ifNone: aBlock! !

!BpmProcessInstance methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 13:07'!
getSingleProcessMapStreamFor: aBpmUser
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: self xmlHeader, String lf, (self generateProcessMapFor: aBpmUser) prettyPrinted.

	^stream! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 10:03'!
getStrokeForActivityNamed: aString user: aBpmUser

	(currentActivities anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.borderColor.running'].

	(executedActivities anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.borderColor.done'].

	(runningGateways anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.borderColor.running'].

	(executedGateways anySatisfy: [:each | each getDefinitionName = aString]) 
	ifTrue: [^aBpmUser getProperty: 'svg.task.borderColor.done'].

	^'darkgray'! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 14:23'!
getSubProcessNamed: aString ifNone: aBlock

	^subprocesses detect: [:each | each getDefinitionName = aString] ifNone: aBlock! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 08:30'!
getTaskNamed: aString ifNone: aBlock

	^self getAllArtifacts detect: [:each | each getDefinitionName = aString] ifNone: aBlock! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 14:02'!
getTopProcess
	"The receiver answer the process at the top level"

	^self subclassResponsibility! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2016 12:17'!
getTotalTime

	self hasFinalized ifTrue: [^self getTotalTimeFrom: (endEvents at: (endEvents keys asArray last)) creationTime].

	^self getTotalTimeFrom: currentActivities last creationTime! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2016 12:16'!
getTotalTimeFrom: aTimeStamp
	| totalTime |

	totalTime := aTimeStamp minusSeconds: createdTime asSeconds.

	^Time fromSeconds: totalTime asSeconds! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 14:25'!
getTotalTimeOfTaskNamed: aString

	^(self getTaskNamed: aString ifNone: [self getSubProcessNamed: aString ifNone: [^Time fromSeconds: 0]]) getTotalTime! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 04/24/2016 15:36'!
getValueOf: fieldName
	"Answer the first value of a field named <fieldName> in the receiver's collection of <executedActivities>.
	The search is performed only in activities that have anOrbeonFormInstance <hasForm>."

	"This method is used inside Bizagi conditions when the name of the field is a valid Smalltalk message.
	[:proc | proc name isEmpty] --> this will execute the valid method #name.
	If a field name of a Form is a valid Smalltalk message then use this method (otherwise the #doesNotUnderstand: mechanism won't be executed and the valid Smalltalk method will be called causing a error in the condition):
	For #name field name must use:
	[:proc | (proc getValueOf: 'name') isEmpty]
	Generic formula:
	[:proc | (proc getValueOf: 'aValidSmalltalkMessage') someComparision]"

	^self getValueOfProcessField: fieldName! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 07/02/2016 13:46'!
getValueOfProcessField: fieldName
	"Answer the first value of a field named <fieldName> in the receiver's collection of <executedActivities>.
	The search is performed only in activities that have anOrbeonFormInstance <hasForm>."
	| treeCollection |

	(executedActivities reverse select: [:each | each hasForm]) 
		do: [:each | (each getValueOfFormField: fieldName) ifNotNil: [:value | ^value]].

	executedScripts reverse do: [:each | (each getValueOfFormField: fieldName) ifNotNil: [:value | ^value]].

	"searching the value in sub and parent processes"
	treeCollection := self getProcessesTreeAsCollection remove: self; yourself. "to avoid stack overflow"

	^(treeCollection detect: [:proc | (proc getValueOfProcessField: fieldName) notNil] ifNone: [nil])
		ifNil: [nil] 
		ifNotNil: [:proc | proc getValueOfProcessField: fieldName]

	"#reverse is used because the process can be recursive (can be more than one field value for a given field name) --> we check for the lastest executed transitions"! !

!BpmProcessInstance methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 13:09'!
getZipProcessMapStreamFor: aBpmUser
	| fileStream fileName |

	fileName := '/tmp/', processName, Lag1MwcRandom new integer printString, '.zip'.

	self createZipFileWithName: fileName for: aBpmUser.

	fileStream := FileStream read: fileName.

	^fileStream! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:16'!
hasAndContext

	^false! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:41'!
hasContextApplications
	"Answer whether or not the receiver has context applications"

	^self getContextApplications notEmpty! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 09:38'!
hasExecutedActivityNamed: aString
	"Answer whether or not the receiver has an executed activity named <aString>.
	This method is used in combination with multi-instance option of a task"

	^self getExecutedArtifacts anySatisfy: [:each | each getDefinitionName = aString]! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/12/2016 07:57'!
hasFieldNamed: aString

	^definition getAllFieldNames includes: aString! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/29/2015 12:33'!
hasFinalized
	"Answer whether or not the receiver has finalized (all tasks has been executed a transition trigger an end event)"

	^endEvents notEmpty! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 01/23/2016 07:26'!
hasOrbeonFormNamed: aString
	"The receiver answer whether or not it hold a form <OrbeonFormDefinition> named <aString>"

	^definition hasOrbeonFormNamed: aString! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:16'!
hasOrContext

	^false! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:16'!
hasRunningGatewayNamed: aString
	"Answer whether or not the receiver has a running gateway named <aString>"

	^runningGateways includesKey: aString! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 04/15/2016 10:37'!
hasSubprocesses

	^subprocesses notEmpty! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 11/07/2016 14:30'!
hasSubProcessNamed: aString
	""

	^(self getSubProcessNamed: aString ifNone: [nil]) notNil! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 09:45'!
hasTaskNamed: aString

	^definition hasTaskNamed: aString! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
id
	^id! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
id: newValue
	id := newValue! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 03/29/2016 13:55'!
includesSubProcess: aBpmProcessInstances
	"Answer whether or not the receiver includes the process <aBpmProcessInstances> as one of it's subprocesses"

	^subprocesses includes: aBpmProcessInstances! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:37'!
indexOfTransition: anBpmArtifactInstance
	"Answer the index of the receiver transition <anBpmArtifactInstance>"

	(executedActivities includes: anBpmArtifactInstance) 
	ifTrue: [^(executedActivities indexOf: anBpmArtifactInstance)].

	(currentActivities includes: anBpmArtifactInstance) 
	ifTrue: [^(executedActivities size) + (currentActivities indexOf: anBpmArtifactInstance)].

	^0! !

!BpmProcessInstance methodsFor: 'other' stamp: 'brunobb 12/11/2017 17:07'!
initialize

	super initialize.

	id := Lag1MwcRandom new integer.
	currentActivities := OrderedCollection new.
	executedActivities := OrderedCollection new.
	transitions := OrderedCollection new.
	subprocesses := OrderedCollection new.
	createdTime := TimeStamp now.
	runningGateways := Dictionary new.
	executedGateways := OrderedCollection new.
	userAssignments := OrderedCollection new.
	endEvents := Dictionary new.
	executedScripts := OrderedCollection new.
	intermediateEvents := Dictionary new.
	states := OrderedCollection with: (BpmRunningState newFor: self).! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'brunobb 10/24/2017 11:59'!
intermediateEvents
	^intermediateEvents! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'brunobb 10/24/2017 11:59'!
intermediateEvents: newValue
	intermediateEvents := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:15'!
isAborted

	^self currentState isAborted! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:27'!
isInCorruptedState
	"NOT IMPLEMENTED"

		^false! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:15'!
isPaused

	^self currentState isPaused! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:14'!
isRunning

	^self currentState isRunning! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:52'!
isSubProcess

	^false! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:52'!
isTopProcess

	^false! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 01/19/2016 09:54'!
moveFromCurrentToExecuted: aBpmTaskInstance
	"The receiver move the bpm activity <aBpmTaskInstance> from the current collection <currentActivities> to the executed collection <executedActivities>"

	currentActivities remove: aBpmTaskInstance ifAbsent: [self throwNoSuchActivityException: aBpmTaskInstance].

	^executedActivities add: aBpmTaskInstance! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:11'!
parentProcess

	self subclassResponsibility! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:28'!
pauseProcess: aBpmUser
	"The receiver switch the <state> to <paused>"

	^states add: (BpmPausedState newFor: self user: aBpmUser)! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
postExecution
	^postExecution! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
postExecution: newValue
	postExecution := newValue! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 11:44'!
printAndContext

	^self subclassResponsibility! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 07:51'!
printCurrentRols
	| currentRols |

	currentActivities ifEmpty: [^''].

	currentRols := ''.
	currentActivities do: [:each | currentRols := currentRols, each printRoleNames, ' | '].

	^currentRols allButLast: 3.! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 11:44'!
printOrContext

	^self subclassResponsibility! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 12/12/2015 13:05'!
printParentName

	^definition printParentName! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 12/10/2015 13:34'!
printProcessState

	^self hasFinalized ifTrue: ['Finished'] ifFalse: ['Running'].! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:41'!
printRunningArtifacts
	| stringRunning |

	stringRunning := ''.
	currentActivities isEmpty ifTrue: [^''].

	currentActivities do: [:each | stringRunning := stringRunning, each getDefinitionName, ' | '].

	^stringRunning allButLast: 3! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 13:56'!
processId

	^id! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 04/15/2016 10:43'!
processName

	^definition processName! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
processName: newValue
	processName := newValue! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 06/01/2016 13:26'!
registerAssignment: aBpmTaskAssignment
	"The receiver register the assignment <aBpmTaskAssignment> that has been taken by <aBpmUser>"

	^userAssignments add: aBpmTaskAssignment! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/29/2015 16:16'!
removeRunningGatewayNamed: aString
	"The receiver remove the gateway named <aString> if not present throw a no running gateway exception"

	^runningGateways removeKey: aString ifAbsent: [self throwGatewayIsNotRunningException: aString]! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:29'!
resumeProcess: aBpmUser
	"The receiver switch the <state> to <running>"

	^states add: (BpmRunningState newFor: self user: aBpmUser)! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
runningGateways
	^runningGateways! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
runningGateways: newValue
	runningGateways := newValue! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
startEvent
	^startEvent! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
startEvent: newValue
	startEvent := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 03/30/2016 16:53'!
startEventIsAnonymous
	"Answer whether or not the start event <BpmStartEventInstance> is an anonynous event (with no trigger/user)"

	^startEvent isAnonymousEvent! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 11/29/2015 16:16'!
startGateway: aBpmGatewayInstance
	"The receiber start executing in it's context the gateway instance <aBpmGatewayInstance>"

	^runningGateways at: aBpmGatewayInstance getDefinitionName put: aBpmGatewayInstance! !

!BpmProcessInstance methodsFor: 'other' stamp: 'brunobb 12/15/2017 11:17'!
stateName

	^self currentState stateName! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'brunobb 12/11/2017 17:04'!
states
	^states! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'brunobb 12/11/2017 17:04'!
states: newValue
	states := newValue! !

!BpmProcessInstance methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 13:16'!
storeOnZip: aZipArchive withFile: aGsFile for: aBpmUser
	|  stream member |

	stream := RWBinaryOrTextStream on: String new. 
	member := aZipArchive 
						addString: (self xmlHeader, (self generateProcessMapFor: aBpmUser) prettyPrinted) 
						as: (processName, '.xpdl').

	member desiredCompressionMethod: ZipArchive compressionDeflated. 

	aZipArchive writeTo: stream. 
	aGsFile nextPutAll: stream contents.

	self subprocesses do: [:each | each storeOnZip: aZipArchive withFile: aGsFile for: aBpmUser].! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
subprocesses
	^subprocesses! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
subprocesses: newValue
	subprocesses := newValue! !

!BpmProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:27'!
taskIsDone: aBpmArtifactInstance
	"The receiver answer whether or not the artifact <aBpmArtifactInstance> has been finalized"

	^executedActivities includes: aBpmArtifactInstance! !

!BpmProcessInstance methodsFor: 'execeptions' stamp: 'BrunoBB 11/29/2015 16:16'!
throwGatewayIsNotRunningException: aString

	^GatewayIsNotRunningException signal: 'The Gateway named [', aString, '] is not running'! !

!BpmProcessInstance methodsFor: 'execeptions' stamp: 'BrunoBB 11/29/2015 16:16'!
throwNoSuchActivityException: aBpmTaskInstance

	^NoSuchActivitytException signal: 'No current activity named [', aBpmTaskInstance getDefinitionName, '] in this process'! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
transitions
	^transitions! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
transitions: newValue
	transitions := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 03/30/2016 16:48'!
triggerStartEvent
	"The receiver start to run it self by finding the outgoing transition of the start event <BpmStartEventInstance>"

	^self triggerStartEventWith: nil! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 03/30/2016 16:49'!
triggerStartEventWith: aBpmUserOrNil
	"The receiver start to run it self by finding the outgoing transition of the start event <BpmStartEventInstance>.
	The event instance is set with the trigger <aBpmUserOrNil>"

	startEvent := BpmStartEventInstance process: self definition: definition startEvent.
	startEvent trigger: aBpmUserOrNil.

	self generateNextTransitionsFrom: startEvent.! !

!BpmProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:16'!
userAssignments
	^userAssignments! !

!BpmProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:16'!
userAssignments: newValue
	userAssignments := newValue! !

!BpmProcessInstance methodsFor: 'execution' stamp: 'BrunoBB 12/10/2015 13:32'!
version

	^definition version! !

!BpmProcessInstance methodsFor: 'xpdl fileout' stamp: 'BrunoBB 01/13/2017 13:00'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

BpmProcessInstance subclass: #BpmSubProcessInstance
	instanceVariableNames: 'parentProcess creatorTask creatorEvent inheritContextApplications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmSubProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/01/2015 12:09'!
creatorEvent
	^creatorEvent! !

!BpmSubProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 12/01/2015 12:09'!
creatorEvent: newValue
	creatorEvent := newValue! !

!BpmSubProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/01/2015 12:09'!
creatorTask
	^creatorTask! !

!BpmSubProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 12/01/2015 12:09'!
creatorTask: newValue
	creatorTask := newValue! !

!BpmSubProcessInstance methodsFor: 'running' stamp: 'BrunoBB 12/02/2015 14:09'!
finalizeWith: aBpmEndEventInstance
	"The receiver is finalized with the end event <aBpmEndEventInstance>"

	super finalizeWith: aBpmEndEventInstance.

	parentProcess generateNextTransitionsFrom: creatorTask "the parent process resume it's execution"! !

!BpmSubProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:10'!
getContextApplications
	
	inheritContextApplications ifFalse: [^OrderedCollection new].

	^parentProcess getContextApplications! !

!BpmSubProcessInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 14:30'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	(anOrderedCollection includes: self) ifTrue: [^anOrderedCollection].

	anOrderedCollection add: self.

	subprocesses do: [:each | each getProcessTree: anOrderedCollection].

	parentProcess getProcessTree: anOrderedCollection.

	^anOrderedCollection! !

!BpmSubProcessInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 14:01'!
getTopProcess
	"The receiver can be a leaft process (without subprocesses) or it can be a middle process (with subprocesses).
	The receivern answer a BpmTopProcess instance at the top level"

	^parentProcess getTopProcess! !

!BpmSubProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/06/2015 12:51'!
inheritContextApplications
	^inheritContextApplications! !

!BpmSubProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 12/06/2015 12:51'!
inheritContextApplications: newValue
	inheritContextApplications := newValue! !

!BpmSubProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 12:51'!
initialize

	super initialize.

	inheritContextApplications := false! !

!BpmSubProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:53'!
isSubProcess

	^true! !

!BpmSubProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:17'!
parentProcess
	^parentProcess! !

!BpmSubProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:17'!
parentProcess: newValue
	parentProcess := newValue! !

!BpmSubProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 11:43'!
printAndContext

	^''! !

!BpmSubProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 11:43'!
printOrContext

	^''! !

BpmProcessInstance subclass: #BpmTopProcessInstance
	instanceVariableNames: 'andContextApplications orContextApplications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:40'!
addAndContextApplication: anOrbeonApplication
	"The receiver add the context application <anOrbeonApplication>.
	In order to interact with the receiver aBpmUser must have roles for the receiver's process definition AND at least one role for one of the context application collection <contextApplications>.
	If <contextApplications> is empty then there is NO restriction on others Application --> aBpmUser must have roles only for receiver's process definition"

	^andContextApplications add: anOrbeonApplication! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:40'!
addOrContextApplication: anOrbeonApplication
	"The receiver add the context application <anOrbeonApplication>.
	In order to interact with the receiver aBpmUser must have roles for the receiver's process definition AND at least one role for one of the context application collection <contextApplications>.
	If <contextApplications> is empty then there is NO restriction on others Application --> aBpmUser must have roles only for receiver's process definition"

	^orContextApplications add: anOrbeonApplication! !

!BpmTopProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/06/2015 13:39'!
andContextApplications
	^andContextApplications! !

!BpmTopProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 12/06/2015 13:39'!
andContextApplications: newValue
	andContextApplications := newValue! !

!BpmTopProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/06/2015 13:42'!
getContextApplications

	^andContextApplications, orContextApplications! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 14:26'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	(anOrderedCollection includes: self) ifTrue: [^anOrderedCollection].

	anOrderedCollection add: self.

	subprocesses do: [:each | each getProcessTree: anOrderedCollection].

	^anOrderedCollection! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 14:02'!
getTopProcess
	"The receiver answer the process at the top level"

	^self! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:15'!
hasAndContext

	^andContextApplications notEmpty! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:15'!
hasOrContext

	^orContextApplications notEmpty! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:42'!
initialize

	super initialize.

	andContextApplications := OrderedCollection new.
	orContextApplications := OrderedCollection new.! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:53'!
isTopProcess

	^true! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 08/04/2016 16:14'!
matchContextsWith: aBpmUser
	"Answer whether or not the receiver has  a context applications that match with the collection of applications in <collectionOfApplications>.
	The <AND> context match for ALL satisfy.
	The <OR> context match for ANY satisfy.
	If any of both <<AND> <OR> is true --> true "
	| userApplications |

	userApplications := aBpmUser getApplications.

	^(andContextApplications notEmpty and: [andContextApplications allSatisfy: [:each | userApplications includes: each]]) 
		or: [orContextApplications anySatisfy: [:each | userApplications includes: each]]! !

!BpmTopProcessInstance methodsFor: 'Accessing' stamp: 'BrunoBB 12/06/2015 13:39'!
orContextApplications
	^orContextApplications! !

!BpmTopProcessInstance methodsFor: 'Updating' stamp: 'BrunoBB 12/06/2015 13:39'!
orContextApplications: newValue
	orContextApplications := newValue! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:10'!
parentProcess

	^nil! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:10'!
printAndContext

	^self printAndContextOn: (PrintStream on: String new)! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:32'!
printAndContextOn: aStream

	andContextApplications isEmpty ifTrue: [^''].

	andContextApplications do: [:each | aStream nextPutAll:  (each applicationName, ' & ')].

	^aStream contents allButLast: 3! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:10'!
printOrContext

	^self printOrContextOn: (PrintStream on: String new)! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:33'!
printOrContextOn: aStream

	orContextApplications isEmpty ifTrue: [^''].

	orContextApplications do: [:each | aStream nextPutAll:  (each applicationName, ' | ')].

	^aStream contents allButLast: 3! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:40'!
removeAndContextApplication: anOrbeonApplication
	"The receiver remove the context application <anOrbeonApplication>.
	In order to interact with the receiver aBpmUser must have roles for the receiver's process definition AND at least one role for one of the context application collection <contextApplications>.
	If <contextApplications> is empty then there is NO restriction on others Application --> aBpmUser must have roles only for receiver's process definition"

	^andContextApplications remove: anOrbeonApplication ifAbsent: []! !

!BpmTopProcessInstance methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 13:40'!
removeOrContextApplication: anOrbeonApplication
	"The receiver remove the context application <anOrbeonApplication>.
	In order to interact with the receiver aBpmUser must have roles for the receiver's process definition AND at least one role for one of the context application collection <contextApplications>.
	If <contextApplications> is empty then there is NO restriction on others Application --> aBpmUser must have roles only for receiver's process definition"

	^orContextApplications remove: anOrbeonApplication ifAbsent: []! !

BpmObject subclass: #BpmProcessState
	instanceVariableNames: 'process timeStamp user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmProcessState commentStamp: 'brunobb 12/11/2017 16:59' prior: 0!
These classes are intented for execution purpose and it is outside of BPM standart.!

BpmProcessState subclass: #BpmAbortedState
	instanceVariableNames: 'isConfirmed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmAbortedState class methodsFor: 'other' stamp: 'brunobb 12/15/2017 12:12'!
stateName

	^'Aborted'! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 01/05/2018 13:54'!
confirmAbortion
"
    - Remove all tasks from BpmRunningTasksMatrix
    - Remove assignments from BpmUsers.
    - Remove timer events from BpmTimerEventMonitor
	- Remove BpmProcessInstance from BpmProcessDefinition processInstances
	- Remove all AppFieldValue subinstances from BpmProcessDefinition formFieldInstances
    - What else ?
"

	isConfirmed ifFalse: [^AbortionNotConfirmedException signal: 'The Aborted state must be confirmed before execution'].

	self removeTakenAssignmentsFromUsers.

	self removeAllAssigmentsFromRunningMatrix.
	self removeAllAssigmentsFromFinishedMatrix.

	self removeTimerEventsFromEventMonitor.

	self removeAppFieldValuesFromProcessDefinition.

	process addToAbortedProcess.! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 12/27/2017 09:12'!
getAllProcessRoles
	"Answer a collection with all <BpmRole> that perform at least one task in the receiver"

	^process getAllRoles! !

!BpmAbortedState methodsFor: 'other' stamp: 'brunobb 12/12/2017 16:56'!
initialize

	super initialize.

	isConfirmed := false! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:14'!
isAborted

	^true! !

!BpmAbortedState methodsFor: 'Accessing' stamp: 'brunobb 12/12/2017 16:56'!
isConfirmed
	^isConfirmed! !

!BpmAbortedState methodsFor: 'Updating' stamp: 'brunobb 12/12/2017 16:56'!
isConfirmed: newValue
	isConfirmed := newValue! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 01/02/2018 14:19'!
removeAllAssigmentsFromFinishedMatrix
	"The receiver remove all <BpmTaskAssignment> from the <BpmRunningTasksMatrix> for the aborted <BpmProcessInstance> <process>"
	| applicationMatrix |

	applicationMatrix := self getFinishedMatrixManagerClass 
									getMatrixForApplicationNamed: process getApplicationName 
									ifAbsent: [^NoMatrixForApplicationException signal: 'No Task Matrix for Application [', process getApplicationName, ']'].

	^self removeAllAssigmentsFromMatrix: applicationMatrix! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 01/02/2018 14:17'!
removeAllAssigmentsFromMatrix: aBpmTasksHolderMatrix
	"The receiver remove all <BpmTaskAssignment> from the <aBpmTasksHolderMatrix> for the aborted <BpmProcessInstance> <process>"
	| processId taskAssigments |

	taskAssigments := Set new.
	processId := process processId.

	"all roles in the <BpmProcessInstance>"
	self getAllProcessRoles do: [:eachRole |
		taskAssigments addAll: (aBpmTasksHolderMatrix getAvailableTasksFor: eachRole name satisfying: {:e | e.processId = processId}).		
	].

	taskAssigments do: [:each | each removeFromMatrix].! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 01/02/2018 12:40'!
removeAllAssigmentsFromRunningMatrix
	"The receiver remove all <BpmTaskAssignment> from the <BpmRunningTasksMatrix> for the aborted <BpmProcessInstance> <process>"
	| applicationMatrix |

	applicationMatrix := self getMatrixManagerClass 
									getMatrixForApplicationNamed: process getApplicationName 
									ifAbsent: [^NoMatrixForApplicationException signal: 'No Task Matrix for Application [', process getApplicationName, ']'].

	^self removeAllAssigmentsFromMatrix: applicationMatrix! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 01/02/2018 14:23'!
removeAppFieldValuesFromProcessDefinition
	"The receiver remove all <AppFieldValue> contained in the <BpmProcessInstance> <process> from the global collection for field values"
	| processDefinition |

	processDefinition := process definition.

	process getAllArtifacts do: [:eachArtifact |
		eachArtifact hasForm ifTrue: [ "maybe the task was created but the form has not been created by any user"
			eachArtifact externalObject fieldValuesDo: [:fieldValueHolder |
				fieldValueHolder currentValues do: [:appFieldValue | 
					processDefinition removeFrom: fieldValueHolder formName fieldValue: appFieldValue.
				].
			].
		].
	].! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 12/31/2017 10:12'!
removeTakenAssignmentsFromUsers
	"The receiver iterate over all <BpmUser> in the System and cancel all <BpmTaskAssignment> relate to <BpmProcessInstance>"

	BpmUser getFrontofficeUsers do: [:eachUser | eachUser cancelTaskAssignmentsForAbortion: process].! !

!BpmAbortedState methodsFor: 'execution' stamp: 'brunobb 01/01/2018 15:32'!
removeTimerEventsFromEventMonitor
	"The receiver remove all events from the event monitor <BpmTimerEventMonitor>"
	| processId eventsToRemove |

	processId := process id.

	eventsToRemove := (GsQuery fromSelectBlock: {:eventInstance | eventInstance.processId = processId} on: self defaultTimerEventMonitor monitoredEvents) queryResult.
	
	eventsToRemove do: [:eventInstance | self defaultTimerEventMonitor stopMonitoringArtifact: eventInstance]! !

BpmProcessState subclass: #BpmPausedState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmPausedState class methodsFor: 'other' stamp: 'brunobb 12/15/2017 12:12'!
stateName

	^'Paused'! !

!BpmPausedState methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:14'!
isPaused

	^true! !

!BpmProcessState class methodsFor: 'other' stamp: 'brunobb 12/11/2017 17:00'!
newFor: aBpmProcessInstance

	^super new initialize
		process: aBpmProcessInstance;
		yourself! !

!BpmProcessState class methodsFor: 'other' stamp: 'brunobb 12/11/2017 17:26'!
newFor: aBpmProcessInstance user: aBpmUser

	^super new initialize
		process: aBpmProcessInstance;
		user: aBpmUser;
		yourself! !

!BpmProcessState class methodsFor: 'other' stamp: 'brunobb 12/15/2017 12:13'!
stateName

	^self subclassResponsibility! !

!BpmProcessState methodsFor: 'other' stamp: 'brunobb 12/31/2017 11:19'!
confirmAbortion
	"Do nothing for all state but <BpmAbortedState>"! !

!BpmProcessState methodsFor: 'other' stamp: 'brunobb 12/15/2017 11:13'!
getStateNameFor: aBpmUSer

	^self stateName translateFor: aBpmUSer! !

!BpmProcessState methodsFor: 'other' stamp: 'brunobb 12/11/2017 17:03'!
hasUser

	^user notNil! !

!BpmProcessState methodsFor: 'other' stamp: 'brunobb 12/11/2017 17:01'!
initialize

	super initialize.

	timeStamp := TimeStamp now! !

!BpmProcessState methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:14'!
isAborted

	^false! !

!BpmProcessState methodsFor: 'other' stamp: 'brunobb 01/04/2018 11:08'!
isConfirmed: aBoolean
	"do nothing"! !

!BpmProcessState methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:13'!
isPaused

	^false! !

!BpmProcessState methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:13'!
isRunning

	^false! !

!BpmProcessState methodsFor: 'Accessing' stamp: 'brunobb 12/11/2017 16:59'!
process
	^process! !

!BpmProcessState methodsFor: 'Updating' stamp: 'brunobb 12/11/2017 16:59'!
process: newValue
	process := newValue! !

!BpmProcessState methodsFor: 'other' stamp: 'brunobb 12/15/2017 12:11'!
stateName

	^self class stateName! !

!BpmProcessState methodsFor: 'Accessing' stamp: 'brunobb 12/11/2017 17:01'!
timeStamp
	^timeStamp! !

!BpmProcessState methodsFor: 'Updating' stamp: 'brunobb 12/11/2017 17:01'!
timeStamp: newValue
	timeStamp := newValue! !

!BpmProcessState methodsFor: 'Accessing' stamp: 'brunobb 12/11/2017 17:02'!
user
	^user! !

!BpmProcessState methodsFor: 'Updating' stamp: 'brunobb 12/11/2017 17:02'!
user: newValue
	user := newValue! !

BpmProcessState subclass: #BpmRunningState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmRunningState class methodsFor: 'other' stamp: 'brunobb 12/15/2017 12:12'!
stateName

	^'Running'! !

!BpmRunningState methodsFor: 'execution' stamp: 'brunobb 12/11/2017 17:14'!
isRunning

	^true! !

BpmObject subclass: #BpmTaskAssignment
	instanceVariableNames: 'assignationDate creationDate roleName processName processId taskName taskEndDate processEndDate process task user matrix hasContextApplications canUnassign'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmTaskAssignment class methodsFor: 'other' stamp: 'BrunoBB 12/04/2015 09:57'!
newFor: aBpmProcessInstance task: aBpmTaskInstance in: aBpmRunningTasksMatrix

	^super new initialize
		setProcess: aBpmProcessInstance;
		setTask: aBpmTaskInstance;
		matrix: aBpmRunningTasksMatrix;
		yourself! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 13:51'!
addToMatrix
	"The receiver call the matrix <aBpmRunningTasksMatrix> to be removed"

	^matrix addAssignment: self! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 04/12/2016 14:04'!
addWorkerUser: aBpmUser
	"The receiver update it's task adding the user <aBpmUser> as the current user with the current role of the task "
	| role |

	role := self getNextRoleIfNone: [^nil].

	task addWorkerUser: aBpmUser as: role.! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 14:15'!
applicationName

	^task applicationName! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 06/01/2016 13:40'!
assignationDate
	^assignationDate! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 06/01/2016 13:40'!
assignationDate: newValue
	assignationDate := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:16'!
assignedUserNames

	^'******'! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/10/2015 13:36'!
canUnassign
	^canUnassign! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/10/2015 13:36'!
canUnassign: newValue
	canUnassign := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 05/30/2016 13:47'!
checkIfIsStillAvailableToTake
	"Answer whether or not the receiver is still available to be taken by a <BpmUser>"

	^(matrix getAvailableTasksFor: roleName) includes: self! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
creationDate
	^creationDate! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 12:13'!
creationDate: newValue
	creationDate := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:34'!
creator
	^process creator! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:16'!
creatorName

	^process creatorName! !

!BpmTaskAssignment methodsFor: 'finalizing' stamp: 'BrunoBB 01/18/2016 13:47'!
finalize
	"The receiver is finalizing.
	1- Set the end timestamp for the <task>.
	2- Finalize the <task>"

	self finishAssignment. "set end time stamp"

	task finalize.! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 04/13/2016 09:31'!
finalizedPerformerCount
	"Answer the number of inner task (of a task) finalized by performers"

	^task finalizedPerformerCounter! !

!BpmTaskAssignment methodsFor: 'finalizing' stamp: 'BrunoBB 01/18/2016 13:47'!
finishAssignment

	taskEndDate := TimeStamp now.! !

!BpmTaskAssignment methodsFor: 'finalizing' stamp: 'BrunoBB 12/11/2015 14:13'!
finishTask

	taskEndDate := TimeStamp now.! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 01/18/2016 15:00'!
free

	self addToMatrix. "is now available for other users to take it"
	self user: nil.! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'brunobb 11/02/2017 07:45'!
generateNextRunningTransitions
	"The receiver <BpmTask> fetch the possibles next transitions to transition definition.
	1- Ask the path definition for next transitions.
	2- Create a concrete transtition for each definition in 1, and add it as running transitions."

	task ifNil: [^nil].

	^task generateNextRunningTransitions! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 01/17/2016 13:05'!
getCurrentRoleIfNone: aBlock

	task ifNil: [^aBlock value].

	^task getCurrentRoleIfNone: aBlock! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:23'!
getExecutedArtifacts

	^process getExecutedArtifacts! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 01/17/2016 14:38'!
getNextRoleIfNone: aBlock

	task ifNil: [^aBlock value].

	^task getNextRoleIfNone: aBlock! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 15:32'!
getRoleName

	self hasPerformers ifFalse: [^roleName].

	^(self getNextRoleIfNone: [^roleName]) name! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:26'!
getRunningArtifacts

	^process getRunningArtifacts! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:15'!
hasAndContext

	hasContextApplications ifFalse: [^false].

	^process hasAndContext! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/06/2015 13:15'!
hasContextApplications
	^hasContextApplications! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/06/2015 13:15'!
hasContextApplications: newValue
	hasContextApplications := newValue! !

!BpmTaskAssignment methodsFor: 'finalizing' stamp: 'BrunoBB 12/10/2015 13:29'!
hasFinalized

	^process hasFinalized! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:15'!
hasOrContext

	hasContextApplications ifFalse: [^false].

	^process hasOrContext! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 04/13/2016 10:17'!
hasPerformers
	"Answer whether or not the task of the receiver has performers.
	Regular task consist in one form or one Seaside Component.
	Task with performers enable to more than one role work in the same task (in sequential way)"

	task ifNil: [^false].

	^task hasPerformers! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 04/12/2016 15:00'!
incrementPerformerCounter
	"The increment in 1 the performer count of it's task <BpmTaskInstance> only if it has performers.
	This is used to know how many task has been finished by performers.
	Without this counter is NOT possible to know if a task has been finished or is been edited by a performer 
	(see task: <rolesWhoWorked> and <usersWhoWorked>) "

	self hasPerformers ifTrue: [task incrementPerformerCounter]! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 01/18/2016 16:53'!
initialize

	super initialize.

	creationDate := TimeStamp now.
	canUnassign := true.
	hasContextApplications := false.! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 08/05/2016 08:38'!
isAvailableFor: aBpmUser
	"The receiver answer whether or not the user <aBpmUser> has a context application that match with context application of <process> <BpmProcessInstance> "

	hasContextApplications ifFalse: [^true]. "if there is no context --> the receiver is available"

	^process matchContextsWith: aBpmUser! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 02/18/2016 12:35'!
isDone

	^task isDone! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 01/18/2016 13:50'!
isFinishedByPerformers

	task ifNil: [^true].

	^task isFinishedByPerformers! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:28'!
isInCorruptedState

	^process isInCorruptedState! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 05/30/2016 13:48'!
isTaken
	"Answer whether or not the receiver is taken by a <BpmUser>"

	^user notNil! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/12/2015 13:02'!
isTopProcess

	^process isTopProcess! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/04/2015 09:53'!
matrix
	^matrix! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/04/2015 09:53'!
matrix: newValue
	matrix := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:13'!
printAndContext

	^process printAndContext! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:12'!
printAssignmentDate

	^creationDate printString! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/12/2015 11:34'!
printCreatorName

	^self creator ifNotNil: [:value | value username] ifNil: ['']! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:15'!
printCurrentRols

	^process printCurrentRols! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'brunobb 01/02/2018 14:09'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',taskName, '(', roleName,')]'! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/19/2015 11:13'!
printOrContext

	^process printOrContext! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/12/2015 13:05'!
printParentName

	^process printParentName! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 11:01'!
printProcessRunningArtifacts

	^process printRunningArtifacts! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:34'!
printProcessState

	^process printProcessState! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 11:00'!
printRunningArtifacts

	^task getDefinitionName! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 06/01/2016 13:48'!
printUserName

	user ifNil: [^'-'].

	^user username! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
process
	^process! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 14:06'!
process: newValue
	process := newValue! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/11/2015 14:13'!
processEndDate
	^processEndDate! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/11/2015 14:13'!
processEndDate: newValue
	processEndDate := newValue! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
processId
	^processId! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 12:13'!
processId: newValue
	processId := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'brunobb 01/12/2018 12:35'!
processIsRunning

	^process isRunning! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
processName
	^processName! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 12:13'!
processName: newValue
	processName := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 06/01/2016 13:28'!
registerInProcess
	"The receiver register it self in the parent process"

	^process registerAssignment: self! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 14:00'!
removeFromMatrix
	"The receiver call the matrix <aBpmRunningTasksMatrix> to be removed"

	^matrix removeAssignment: self! !

!BpmTaskAssignment methodsFor: 'performers' stamp: 'BrunoBB 01/18/2016 09:37'!
removeLastWorker

	^task removeLastWorker! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 13:29'!
resetAll

	process := task := user := matrix := nil.! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
roleName
	^roleName! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 12:13'!
roleName: newValue
	roleName := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 06/01/2016 13:41'!
setAssignationDate

	assignationDate := TimeStamp now.! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/06/2015 13:19'!
setProcess: aBpmProcessInstance
	"The receiver set it process wtih <aBpmProcessInstance> and set process related data"

	process := aBpmProcessInstance.
	processId := aBpmProcessInstance id.
	processName := aBpmProcessInstance processName.
	hasContextApplications := aBpmProcessInstance hasContextApplications.! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/18/2015 15:17'!
setTask: aBpmTaskInstance
	"The receiver set it task wtih <aBpmTaskInstance> and set related data"

	task := aBpmTaskInstance.
	taskName := aBpmTaskInstance getDefinitionName.

	hasContextApplications := process hasContextApplications! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
task
	^task! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 12:13'!
task: newValue
	task := newValue! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/11/2015 14:13'!
taskEndDate
	^taskEndDate! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/11/2015 14:13'!
taskEndDate: newValue
	taskEndDate := newValue! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
taskName
	^taskName! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 12:13'!
taskName: newValue
	taskName := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 15:26'!
updatetRoleName
	| nextRole |

	nextRole := self getNextRoleIfNone: [^roleName].

	roleName := nextRole name! !

!BpmTaskAssignment methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2015 12:13'!
user
	^user! !

!BpmTaskAssignment methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2015 12:13'!
user: newValue
	user := newValue! !

!BpmTaskAssignment methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:30'!
version

	^process version! !

BpmObject subclass: #BpmTaskLoopCounter
	instanceVariableNames: 'counter iterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmTaskLoopCounter methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 10:36'!
addIteration: aBpmArtifactInstance

	counter := counter + 1.

	iterations at: counter put: aBpmArtifactInstance! !

!BpmTaskLoopCounter methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 10:30'!
counter
	^counter! !

!BpmTaskLoopCounter methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 10:30'!
counter: newValue
	counter := newValue! !

!BpmTaskLoopCounter methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 10:35'!
initialize

	super initialize.

	counter := 0.
	iterations := Dictionary new.! !

BpmObject subclass: #BpmTasksHolderMatrix
	instanceVariableNames: 'application rolesAndAssignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmTasksHolderMatrix class
	instanceVariableNames: 'cache'!

BpmTasksHolderMatrix subclass: #BpmFinishedTasksMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

BpmTasksHolderMatrix subclass: #BpmRunningTasksMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmTasksHolderMatrix class methodsFor: 'Accessing' stamp: 'BrunoBB 12/28/2015 11:08'!
cache

	cache ifNil: [self initializeCache].

	^cache! !

!BpmTasksHolderMatrix class methodsFor: 'Updating' stamp: 'BrunoBB 12/22/2015 10:22'!
cache: newValue
	cache := newValue! !

!BpmTasksHolderMatrix class methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:37'!
getAllAvailableTaskAssignments
	"The receiver answer a collection with all running/pending tasks in all Applications"

	^self getAllAvailableTaskAssignmentsIn: self getApplicationsCache! !

!BpmTasksHolderMatrix class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:32'!
getAllAvailableTaskAssignmentsIn: anOrderedCollection
	"The receiver answer a collection with all running/pending tasks for all Applications contained in collection <anOrderedCollection>"
	| tasks |

	tasks := OrderedCollection new.
	anOrderedCollection do: [:eachApp |  | matrix |
		matrix := self getMatrixForApplicationNamed: eachApp applicationName. "get the Matrix for the Application"
		matrix rolesAndAssignment do: [:tasksAssign | tasks addAll: tasksAssign asArray]]. "add tasks"

	^tasks! !

!BpmTasksHolderMatrix class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:37'!
getMatrixForApplicationNamed: aString
	"The receiver answer an instance of itself for the Application named <aString>.
	If the Matrix does not exist --> create a newone.
	If the Application does not exist --> throw an exception"
	| application |

	application := self getApplicationManagerClass getAnyApplicationNamed: aString ifNone: [^NoProcessMatrixException signal: 'No Matrix has been created for process named [', aString, ']'].

	^self getMatrixForApplicationNamed: aString ifAbsent: [self newFor: application]! !

!BpmTasksHolderMatrix class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:28'!
getMatrixForApplicationNamed: aString ifAbsent: aBlock
	"The receiver answer an instance of itself for the Application named <aString> if none evaluates the zero argument block <aBlock>."

	^self cache at: aString ifAbsent: aBlock! !

!BpmTasksHolderMatrix class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:22'!
initializeCache

	cache := Dictionary new! !

!BpmTasksHolderMatrix class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:30'!
newFor: anOrbeonApplication

	^super new initialize
		application: anOrbeonApplication;
		addToCache;
		yourself! !

!BpmTasksHolderMatrix class methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 14:34'!
resetAll

	^self cache do: [:each | each resetAll] "set <rolesAndAssignment> to Dictionary new"! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 01/18/2016 15:03'!
addAssignment: aBpmTaskAssignment
	"The receiver add the task assignment <aBpmTaskAssignment> from it's task collection."

	aBpmTaskAssignment matrix: self.

	^(rolesAndAssignment at: aBpmTaskAssignment getRoleName ifAbsent: [self createSlotFor: aBpmTaskAssignment getRoleName])
			add: aBpmTaskAssignment! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 07/26/2016 14:55'!
addTask: aBpmTaskInstance
	"The receiver create an asignment based on task <aBpmTaskInstance> to be listed as available for the users"
	| newAssignments |

	newAssignments := 
			aBpmTaskInstance hasPerformers "size > 1- In order to use <performers> there must be at least two <performers>"
			ifFalse: [ "the roles of the task are used to create assignments"
				aBpmTaskInstance getRoles collect: [:eachRole | self createAssingmentForRole: eachRole inTask: aBpmTaskInstance.
				]
			]
			ifTrue: ["the performers of the task are used to create assignments"
				self updatePerformersOf: aBpmTaskInstance.
			].

	^newAssignments select: [:each | each notNil] "#updatePerformersOf: can answer nil"! !

!BpmTasksHolderMatrix methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:32'!
addToCache

	application ifNil: [^self throwExceptionNoOrbeonApplication].

	^self class cache at: application applicationName put: self! !

!BpmTasksHolderMatrix methodsFor: 'Accessing' stamp: 'BrunoBB 12/22/2015 10:30'!
application
	^application! !

!BpmTasksHolderMatrix methodsFor: 'Updating' stamp: 'BrunoBB 12/22/2015 10:30'!
application: newValue
	application := newValue! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 07/26/2016 14:54'!
createAssingmentForRole: aBpmRole inTask: aBpmTaskInstance
	"The receiver create an asignment based on task <aBpmTaskInstance> to be listed as available for the users"

	^self addAssignment: (aBpmTaskInstance asAssignmentFor: aBpmRole in: self). "answer <aBpmTaskAssignment>"! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 12/22/2015 10:32'!
createSlotFor: roleName
	"The receiver creates a slot/collection to hold <BpmProcessInstance> where the role named <roleName> is granted.
	This slot/collection can have process with different <BpmProcessDefinition> because the same <BpmRole> can participate in different processes"

	"Inside <RcIdentityBag> create an index by <each.processName> to split by process type"

	^rolesAndAssignment at: roleName put: RcIdentityBag new! !

!BpmTasksHolderMatrix methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:32'!
getAssignmentFor: aBpmTaskInstance
	"Answer the associated task assignment <aBpmTaskAssignment> to the task <aBpmTaskInstance>.
	If the task assignment is not foud the evaluate the zero argument block <aBlock>"

	^self getAssignmentFor: aBpmTaskInstance ifNone: [nil]! !

!BpmTasksHolderMatrix methodsFor: 'other' stamp: 'BrunoBB 04/01/2016 14:20'!
getAssignmentFor: aBpmTaskInstance ifNone: aBlock
	"Answer the associated task assignment <aBpmTaskAssignment> to the task <aBpmTaskInstance>.
	If the task assignment is not found the evaluate the zero argument block <aBlock>"
	| responsible |

	responsible := aBpmTaskInstance hasPerformers
		ifTrue: [aBpmTaskInstance getPerformers] "check in performers for the <BpmTaskAssignment> of task <BpmTaskInstance>"
		ifFalse: [aBpmTaskInstance getRoles]. "check in roles for the <BpmTaskAssignment> of task <BpmTaskInstance>"
	
	responsible do: [:eachRole | 
		(self getAvailableTasksFor: eachRole name) do: [:assignTask | (assignTask task == aBpmTaskInstance) ifTrue: [^assignTask]]].

	^aBlock value! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 08/06/2016 12:19'!
getAvailableTasksFor: roleName
	"Answer a (reduce conflict and indexable) collection with all available/free tasks for the role named <roleName>"

	^rolesAndAssignment at: roleName ifAbsent: [RcIdentityBag new]! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 08/06/2016 12:02'!
getAvailableTasksFor: roleName satisfying: aBlock
	"Answer a (reduce conflict and indexable) collection with all tasks for the role named <roleName>.
	Apply to the result the filter block <aBlock>
	To use indexes: aBlock: 
	{:e | e.processId = 3336433824} "
	| rcCollection |

	rcCollection := self getAvailableTasksFor: roleName.

	^(GsQuery fromSelectBlock: aBlock on: rcCollection) queryResult! !

!BpmTasksHolderMatrix methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:32'!
initialize

	super initialize.

	rolesAndAssignment := Dictionary new.! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 01/17/2016 14:00'!
removeAssignment: aBpmTaskAssignment
	"The receiver remove the task assignment <aBpmTaskAssignment> from it's task collection.
	1- Get the collection for the task role
	2- Remove the object"

	^(rolesAndAssignment at: aBpmTaskAssignment getRoleName ifAbsent: [self throwExceptionNoSlotFor: aBpmTaskAssignment roleName])
			remove: aBpmTaskAssignment
			ifAbsent: [self throwExceptionTaskAssignmentNotFound]! !

!BpmTasksHolderMatrix methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 14:30'!
resetAll

	rolesAndAssignment do: [:eachCollection | 
		eachCollection do: [:taskAssignment | 
			"reset: [process, task, user, matrix] := nil."
			taskAssignment resetAll]].

	rolesAndAssignment := Dictionary new.! !

!BpmTasksHolderMatrix methodsFor: 'Accessing' stamp: 'BrunoBB 12/22/2015 10:30'!
rolesAndAssignment
	^rolesAndAssignment! !

!BpmTasksHolderMatrix methodsFor: 'Updating' stamp: 'BrunoBB 12/22/2015 10:30'!
rolesAndAssignment: newValue
	rolesAndAssignment := newValue! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 12/22/2015 10:32'!
sendAssignment: aBpmTaskAssignment from: currentRoleName to: nextRoleName
	"The receiver send in the matrix the process node <aBpmTaskAssignment> from the current role <currentRoleName> to the next role <nextRoleName>.
	This happend when a task is finished by a user and the next tasks are created based on the process definition.
	If <currentRoleName> is equal to <nextRoleName> nothing should happend"
	| currentCollection nextCollection |

	(currentRoleName = nextRoleName) ifTrue: [^aBpmTaskAssignment].

	currentCollection := rolesAndAssignment at: currentRoleName ifAbsent: [self throwExceptionNoSlotFor: currentRoleName].
	nextCollection := rolesAndAssignment at: nextRoleName ifAbsent: [self throwExceptionNoSlotFor: nextRoleName].

	currentCollection remove: aBpmTaskAssignment 
							ifAbsent: [self throwExceptionNoProcessFoundToMoveFrom: currentRoleName to: nextRoleName].

	^nextCollection add: aBpmTaskAssignment! !

!BpmTasksHolderMatrix methodsFor: 'exceptions' stamp: 'BrunoBB 02/07/2016 15:35'!
throwExceptionNoOrbeonApplication

	^NoApplicationException signal: 'A Running Process Matrix must belong to anOrbeonApplication'! !

!BpmTasksHolderMatrix methodsFor: 'exceptions' stamp: 'BrunoBB 12/22/2015 10:32'!
throwExceptionNoProcessFoundToMoveFrom: currentRoleName to: nextRoleName

	^NoProcessToMatrixMoveException signal: 'There is no process to move from [', currentRoleName, '] to [', nextRoleName, ']'! !

!BpmTasksHolderMatrix methodsFor: 'exceptions' stamp: 'BrunoBB 12/22/2015 10:32'!
throwExceptionNoSlotFor: roleName

	^NoMatrixSlotException signal: 'There is no slot/collection for role named [', roleName, ']'! !

!BpmTasksHolderMatrix methodsFor: 'task handling' stamp: 'BrunoBB 08/04/2016 16:06'!
updatePerformersOf: aBpmTaskInstance
	| performer role |

	performer := aBpmTaskInstance getCurrentPerformerIfNone: [^nil]. "if <rolesWhoWorked> is empty --> get the first"
	role := aBpmTaskInstance getRoleForPerformer: performer.
	^OrderedCollection with: (self createAssingmentForRole: role inTask: aBpmTaskInstance).! !

BpmObject subclass: #BpmTimerEventMonitor
	instanceVariableNames: 'processesCreationEventHistory tasksCreationEventHistory monitoredProcessDefinitions monitoredProcessInstances monitoredEvents'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmTimerEventMonitor class methodsFor: 'other' stamp: 'brunobb 07/31/2017 13:21'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!BpmTimerEventMonitor class methodsFor: 'other' stamp: 'brunobb 08/10/2017 13:12'!
getAllMonitoredProcessDefinition
	"The receiver answer a collection with all <BpmProcessDefinition> being monitored to create process instances automatically"

	^self default getAllMonitoredProcessDefinition! !

!BpmTimerEventMonitor class methodsFor: 'other' stamp: 'brunobb 09/03/2017 14:02'!
initializeDefault

	Default := super new initialize! !

!BpmTimerEventMonitor methodsFor: 'monitor process creation' stamp: 'brunobb 08/10/2017 13:11'!
getAllMonitoredProcessDefinition
	"The receiver answer a collection with all <BpmProcessDefinition> being monitored to create process instances automatically"
	| allMonitored |

	allMonitored := OrderedCollection new.
	monitoredProcessDefinitions do: [:proDictionary | 
		proDictionary do: [:procCollection | allMonitored addAll: procCollection ]].

	^allMonitored! !

!BpmTimerEventMonitor methodsFor: 'monitor process artifact' stamp: 'brunobb 11/02/2017 12:55'!
getLastEventInstanceExecutionFor: aBpmEventInstance
	"The receiver answer <aTimeStamp> the latest execution for the event <aBpmEventInstance>"
	| bpmProcess lastEvent |

	bpmProcess := aBpmEventInstance process.

	"if there is none previous executed event --> the first event is taken as the last"
	lastEvent := bpmProcess getLastEventNamed: aBpmEventInstance getDefinitionName ifNone: [aBpmEventInstance].

	^lastEvent creationTime! !

!BpmTimerEventMonitor methodsFor: 'monitor process creation' stamp: 'brunobb 09/04/2017 05:41'!
getLastProcessCreationTimeFor: aBpmProcessDefinition
	"The receiver answer <aTimeStamp> of the last process creation executed for <aBpmProcessDefinition>.
	If there is NO process creation then answer a <aTimeStamp> with the oldest possible value"
	| procNameDictionary procInstancesCollection |

	procNameDictionary := processesCreationEventHistory at: aBpmProcessDefinition applicationName
								ifAbsent: [processesCreationEventHistory at: aBpmProcessDefinition applicationName put: Dictionary new] 
								ifPresent: [:dict | dict].

	procInstancesCollection := procNameDictionary at: aBpmProcessDefinition processName 
									ifAbsent: [procNameDictionary at: aBpmProcessDefinition processName put: OrderedCollection new] 
									ifPresent: [:dictionary | dictionary].

	^(procInstancesCollection select: [:each | each version = aBpmProcessDefinition version]) 
		ifNotEmpty: [:value | value last createdTime]
		ifEmpty: [TimeStamp fromString: '1-10-1970 11:55:00 am' ]! !

!BpmTimerEventMonitor methodsFor: 'other' stamp: 'brunobb 10/20/2017 12:33'!
initialize

	super initialize.

	"used for <BpmProcessDefinition> that have a Timer on the StartEvent [a new <BpmProcessInstance> is created each X time]"
	"in this collection the <BpmProcessDefinition> are NOT removed (the only exception is when the <BpmProcessDefinition> is removed from the System)"
	monitoredProcessDefinitions := Dictionary new.

	"used for <BpmProcessInstance> with Timer on an IntermediateEvent [a new <BpmActivityInstance> is created each X time] "
	"each time a <BpmProcessInstance> is finished then the process instance is removed from this collection"
	"while iterating over the collection if a <BpmProcessInstance> is finished then is removed in that moment"
	monitoredProcessInstances := Dictionary new.

	"all executed TimerEvents"
	processesCreationEventHistory := Dictionary new.
	tasksCreationEventHistory := Dictionary new.

	monitoredEvents := RcIdentityBag new.! !

!BpmTimerEventMonitor methodsFor: 'Accessing' stamp: 'brunobb 10/20/2017 12:31'!
monitoredEvents
	^monitoredEvents! !

!BpmTimerEventMonitor methodsFor: 'Updating' stamp: 'brunobb 10/20/2017 12:31'!
monitoredEvents: newValue
	monitoredEvents := newValue! !

!BpmTimerEventMonitor methodsFor: 'Accessing' stamp: 'brunobb 07/31/2017 13:22'!
monitoredProcessDefinitions
	^monitoredProcessDefinitions! !

!BpmTimerEventMonitor methodsFor: 'Updating' stamp: 'brunobb 07/31/2017 13:22'!
monitoredProcessDefinitions: newValue
	monitoredProcessDefinitions := newValue! !

!BpmTimerEventMonitor methodsFor: 'Accessing' stamp: 'brunobb 07/31/2017 13:22'!
monitoredProcessInstances
	^monitoredProcessInstances! !

!BpmTimerEventMonitor methodsFor: 'Updating' stamp: 'brunobb 07/31/2017 13:22'!
monitoredProcessInstances: newValue
	monitoredProcessInstances := newValue! !

!BpmTimerEventMonitor methodsFor: 'Accessing' stamp: 'brunobb 07/31/2017 13:26'!
processesCreationEventHistory
	^processesCreationEventHistory! !

!BpmTimerEventMonitor methodsFor: 'Updating' stamp: 'brunobb 07/31/2017 13:26'!
processesCreationEventHistory: newValue
	processesCreationEventHistory := newValue! !

!BpmTimerEventMonitor methodsFor: 'monitor process artifact' stamp: 'brunobb 10/20/2017 12:33'!
startMonitoringArtifact: aBpmArtifactInstance
	"The receiver includes <aBpmArtifactInstance> to be monitored for task with timers or timer events.
	The time span of <aBpmArtifactInstance> depends on its definition"

	^monitoredEvents add: aBpmArtifactInstance! !

!BpmTimerEventMonitor methodsFor: 'monitor process creation' stamp: 'brunobb 08/08/2017 12:19'!
startMonitoringProcessCreation: aBpmProcessDefinition
	"The receiver includes <aBpmProcessDefinition> to be monitored for automatic process creation.
	The time span between processes creation depends on the Timer inside <aBpmProcessDefinition>"
	| procDefDictionary monitorCollection |

	aBpmProcessDefinition hasCreationTimer 
	ifFalse: [ProcessDefinitionWithoutTimerException signal: 'The Process Definition [', aBpmProcessDefinition processName, '] does NOT have any creation Timer'].

	procDefDictionary := monitoredProcessDefinitions at: aBpmProcessDefinition applicationName
								ifAbsent: [monitoredProcessDefinitions at: aBpmProcessDefinition applicationName put: Dictionary new] 
								ifPresent: [:dict | dict].

	monitorCollection := procDefDictionary at: aBpmProcessDefinition processName 
									ifAbsent: [procDefDictionary at: aBpmProcessDefinition processName put: Set new] 
									ifPresent: [:collection | collection].

	^monitorCollection add: aBpmProcessDefinition! !

!BpmTimerEventMonitor methodsFor: 'monitor all' stamp: 'brunobb 12/27/2017 16:25'!
startUninterruptedLoop
	"The receiver start an uninterrupted loop checking all Timer in the System.
	This method is intented to be called by a Bash program and should NOT be used inside a Smalltalk Development Environment (exception may apply at development time)"


	[true] whileTrue: [ 

		self triggerArtifactTimers.
		self triggerProcessCreation.

		(Delay forSeconds: 600) wait. "rest for 10 minutes"
	].! !

!BpmTimerEventMonitor methodsFor: 'monitor process artifact' stamp: 'brunobb 10/20/2017 12:40'!
stopMonitoringArtifact: aBpmArtifactInstance
	"The receiver stop monitoring <aBpmArtifactInstance> "

		^monitoredEvents remove: aBpmArtifactInstance ifAbsent: [EventInstanceNotFoundException signal: 'This Event is NOT being Monitored !!!!!!']! !

!BpmTimerEventMonitor methodsFor: 'monitor process creation' stamp: 'brunobb 08/24/2017 10:47'!
stopMonitoringProcessCreation: aBpmProcessDefinition
	"The receiver stop the monitoring of <aBpmProcessDefinition> for automatic process creation."
	| appDictionary monitorCollection |

	aBpmProcessDefinition hasCreationTimer 
	ifFalse: [ProcessDefinitionWithoutTimerException signal: 'The Process Definition [', aBpmProcessDefinition processName, '] does NOT have any creation Timer'].

	appDictionary := monitoredProcessDefinitions at: aBpmProcessDefinition applicationName 
								ifAbsent: [ProcessDefinitionNotFoundException signal: 'This Process is NOT being Monitored !!!!!!'].

	monitorCollection := appDictionary at: aBpmProcessDefinition processName 
									ifAbsent: [ProcessDefinitionNotFoundException signal: 'This Process is NOT being Monitored !!!!!!'].

	^monitorCollection remove: aBpmProcessDefinition ifAbsent: [ProcessDefinitionNotFoundException signal: 'This Process is NOT being Monitored !!!!!!']! !

!BpmTimerEventMonitor methodsFor: 'Accessing' stamp: 'brunobb 07/31/2017 13:26'!
tasksCreationEventHistory
	^tasksCreationEventHistory! !

!BpmTimerEventMonitor methodsFor: 'Updating' stamp: 'brunobb 07/31/2017 13:26'!
tasksCreationEventHistory: newValue
	tasksCreationEventHistory := newValue! !

!BpmTimerEventMonitor methodsFor: 'monitor process artifact' stamp: 'brunobb 10/25/2017 07:24'!
triggerArtifactTimers
	"The receiver iterate over <monitoredEvents> collection and evaluate the timer block of each event instance using the time stamp <TimeStamp now>.
	If true then event is triggered"

	self triggerArtifactTimersWith: TimeStamp now! !

!BpmTimerEventMonitor methodsFor: 'monitor process artifact' stamp: 'brunobb 12/20/2017 13:00'!
triggerArtifactTimersWith: aTimeStamp
	"The receiver iterate over <monitoredEvents> collection and evaluate the timer block of each event instance using the time stamp <aTimeStamp>.
	If the timer block is true and the process is running (could be paused) then event is triggered"

	monitoredEvents do: [:eventInstance | | lastExecutionTime |

		lastExecutionTime := self getLastEventInstanceExecutionFor: eventInstance.

		((eventInstance getTimerBlock value: lastExecutionTime value: aTimeStamp value: eventInstance process) and: [eventInstance process isRunning])
		ifTrue: [eventInstance generateNextRunningTransitions].
	].


"timer block:

[:lastExecutedTime :currentTime :process | (lastExecutedTime plusSeconds: 180) <= currentTime ]

"! !

!BpmTimerEventMonitor methodsFor: 'monitor process creation' stamp: 'brunobb 10/24/2017 14:56'!
triggerProcessCreation
	"The receiver iterate over all process definition <BpmProcessDefinition> with timer creation and create corresponding process instances <BpmProcessInstance> if required"

	^self triggerProcessCreationWith: TimeStamp now! !

!BpmTimerEventMonitor methodsFor: 'monitor process creation' stamp: 'brunobb 10/24/2017 14:56'!
triggerProcessCreationWith: aTimeStamp
	"The receiver iterate over all process definition <BpmProcessDefinition> with timer creation and create corresponding process instances <BpmProcessInstance> if required"

	self getAllMonitoredProcessDefinition do: [:processDefinition | | timerBlock lastExecutionTime processInstance |
		timerBlock := processDefinition getStartTimerBlock.
		lastExecutionTime := self getLastProcessCreationTimeFor: processDefinition.
		(timerBlock value: lastExecutionTime value: aTimeStamp)  "evaluates the Timer Block"
		ifTrue: [processInstance := processDefinition createAndStartProcessInstance: nil. "create the <BpmProcessInstance>"
					self updateLastExecutionTimeFor: processInstance].
	].! !

!BpmTimerEventMonitor methodsFor: 'monitor process creation' stamp: 'brunobb 10/15/2017 09:31'!
updateLastExecutionTimeFor: aBpmProcessInstance
	"The receiver update the last execution time for process instance <aBpmProcessInstance>.
	It means the process execution time span (currentTime - lastExecution >=  process execution time span) have been exceeded and new process must be created"
	| procNameDictionary procInstancesCollection |

	procNameDictionary := processesCreationEventHistory at: aBpmProcessInstance applicationName
								ifAbsent: [processesCreationEventHistory at: aBpmProcessInstance applicationName put: Dictionary new] 
								ifPresent: [:dict | dict].

	procInstancesCollection := procNameDictionary at: aBpmProcessInstance processName 
									ifAbsent: [procNameDictionary at: aBpmProcessInstance processName put: OrderedCollection new] 
									ifPresent: [:dictionary | dictionary].


	^procInstancesCollection add: aBpmProcessInstance! !

BpmObject subclass: #BpmTransitionInstance
	instanceVariableNames: 'definition startArtifact endArtifact'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmTransitionInstance class methodsFor: 'other' stamp: 'BrunoBB 11/12/2015 11:29'!
definition: aBpmTransitionDefinition

	^super new initialize
		definition: aBpmTransitionDefinition;
		yourself! !

!BpmTransitionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 12:55'!
definition
	^definition! !

!BpmTransitionInstance methodsFor: 'Updating' stamp: 'BrunoBB 11/01/2015 12:55'!
definition: newValue
	definition := newValue! !

!BpmTransitionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 12:55'!
endArtifact
	^endArtifact! !

!BpmTransitionInstance methodsFor: 'task connectors' stamp: 'BrunoBB 11/16/2015 18:11'!
endArtifact: aBpmArtifactInstance
	"The receiver set the end artifact with <aBpmArtifactInstance>.
	Also the receiver is an incomming transition of <aBpmArtifactInstance>"

	endArtifact := aBpmArtifactInstance.

	aBpmArtifactInstance addIncommingTransition: self.! !

!BpmTransitionInstance methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 09:09'!
endArtifactName

	^self endArtifact getDefinitionName! !

!BpmTransitionInstance methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 14:41'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', definition name, '] {(', startArtifact printOnType, ')',startArtifact name, '} >> {(', endArtifact printOnType, ')', endArtifact name, '}'.! !

!BpmTransitionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 12:55'!
startArtifact
	^startArtifact! !

!BpmTransitionInstance methodsFor: 'task connectors' stamp: 'BrunoBB 11/16/2015 18:11'!
startArtifact: aBpmArtifactInstance
	"The receiver set the start artifact with <aBpmArtifactInstance>.
	Also the receiver is an outgoing transition of <aBpmArtifactInstance>"

	startArtifact := aBpmArtifactInstance.

	aBpmArtifactInstance addOutgoingTransition: self.! !

!BpmTransitionInstance methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 09:09'!
startArtifactName

	^self startArtifact getDefinitionName! !

BpmObject subclass: #BpmUser
	instanceVariableNames: 'centralUser roles userOptions inbox outbox'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 06:38'!
addAdminUser
	| user role |

	BpmApplication basicInitializeCache.
	BpmApplication applicationNamed: 'admins' ifNone: [(BpmApplication newNamed: 'admins') addToCache].
	
	user := self newUsername: 'admin' password: 'admin'.

	role := BpmBackofficeRole createNewOrGetExisting: 'admin' in: 'admins'.
	role isAdmin: true. 

	role grantUser: user.! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 14:51'!
cache

	Cache ifNil: [self initializeCache].

	^Cache! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 14:51'!
cache: aCollection

	^Cache := aCollection! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 15:07'!
getExistingOrNewUserNamed: aString
	"The receiver answer a user named <aString>.
	If the user does not exist creates a new one with password <password>"

	^self getExistingOrNewUserNamed: aString password: ''! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 04/23/2016 14:58'!
getExistingOrNewUserNamed: aString password: password
	"The receiver answer a user named <aString>.
	If the user does not exist creates a new one with password <password>"

	(self getUserNamed: aString) ifNotNil: [:user | ^user].

	^self newUsername: aString password: password! !

!BpmUser class methodsFor: 'other' stamp: 'brunobb 12/27/2017 13:23'!
getFrontofficeUsers

	^self cache select: [:each | each isFrontOfficeUser]! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 13:14'!
getUserNamed: aString

	^self cache at: aString ifAbsent: [nil]! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 08:18'!
initializeCache

	Cache := RcKeyValueDictionary new! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:39'!
migrateToApplicationUser

	self cache do: [:eachUser | 
		eachUser class migrateTo: BpmUser.
		eachUser migrate]! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:08'!
newUsername: username password: password 
	| user centralUser |

	centralUser := ApplicationUser getExistingOrNewUserNamed: username.
	centralUser password: password.

	user := self new initialize.
	user centralUser: centralUser.

	user addToCache.

	^user! !

!BpmUser class methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 14:29'!
resetAll
	"Reset all user's inboxes"

	^self cache do: [:each | each resetAll]! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 11/22/2015 13:19'!
addRole: aBpmRole

	^roles add: aBpmRole! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 12:25'!
addToCache

	"not allowed to add two user with the same <username>"
	(self class cache includesKey: self username) ifTrue: [^self class cache at: self username].

	^self class cache at: self username put: self! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 04:20'!
atProperty: named put: value

	^userOptions atProperty: named put: value! !

!BpmUser methodsFor: 'other' stamp: 'brunobb 07/27/2017 05:56'!
baseUrlDocumentation

	^self getGemStoneServerConfiguration baseUrlDocumentation! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 07/31/2016 13:54'!
basicFinalizeAssignment: aBpmTaskAssignment
	"The receiver finalize the assignment <aBpmTaskAssignment>"
	
	^self basicFinalizeAssignment: aBpmTaskAssignment takeNext: false! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 07/31/2016 13:54'!
basicFinalizeAssignment: aBpmTaskAssignment takeNext: aBoolean
	"The receiver finalize the assignment <aBpmTaskAssignment>"
	| assignmentFinalization |

	assignmentFinalization := BpmAssignmentFinalization on: aBpmTaskAssignment by: self.
	aBoolean ifTrue: [assignmentFinalization setUserToTakeNextTasks].
	"1- move assignment from <user> current to <user> finished assignments.
	2- Get Global Finished Matrix and add the new finished assignment <aBpmTaskAssignment>.
	3- Generate next transitions for the Process"
	assignmentFinalization finalizeAssignment.

	^assignmentFinalization! !

!BpmUser methodsFor: 'assignment' stamp: 'brunobb 01/02/2018 13:41'!
cancelTaskAssignmentsForAbortion: aBpmProcessInstance
	"The receiver cancel all <BpmTaskAssignment> taken by the receiver because the <BpmProcessInstance> has been aborted"
	| takenAssigments |

	takenAssigments := OrderedCollection withAll: self getCurrentAssigments.

	(takenAssigments select: [:eachAssignment | eachAssignment process == aBpmProcessInstance]) do: [:eachAssignment |  

		eachAssignment user: nil. "add to free matrix, user set to nil"

		"remove the <aBpmTaskAssignment> from the inbox"
		self getCurrentAssigmentsInbox removeEntry: eachAssignment ifAbsent: [self throwExceptionTaskAssignmentNotFound].

	].! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 17:52'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"

	^roles isEmpty and:[self getCurrentAssigmentsInbox isEmpty]! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:23'!
centralUser
	^centralUser! !

!BpmUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:23'!
centralUser: newValue
	centralUser := newValue! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 12/08/2015 09:46'!
currentLanguage

	^userOptions languageName! !

!BpmUser methodsFor: 'assignment' stamp: 'brunobb 12/13/2017 17:01'!
finalizeAssignment: aBpmTaskAssignment
	"The receiver finalize the assignment <aBpmTaskAssignment>.
	If the assignment <aBpmTaskAssignment> has performers --> more than one role are going to work with the assignment.
	If the assignment <aBpmTaskAssignment>  has NO performers --> only one role is granted to work with"

	^self finalizeAssignment: aBpmTaskAssignment takeNext: false! !

!BpmUser methodsFor: 'assignment' stamp: 'brunobb 01/12/2018 12:59'!
finalizeAssignment: aBpmTaskAssignment takeNext: aBoolean
	"The receiver finalize the assignment <aBpmTaskAssignment>.
	If the assignment <aBpmTaskAssignment> has performers --> more than one role are going to work with the assignment.
	If the assignment <aBpmTaskAssignment>  has NO performers --> only one role is granted to work with"

	"if the process has been paused or aborted --> <aBpmTaskAssignment> can not be finalized (the process is freeze)"
	aBpmTaskAssignment process isRunning ifFalse: [^ProcessNotRunningException signal: 'The assigment can not be finalized because the process is NOT [running]'].

	"a manager has untaken the assignment from the receiver --> the assignment can NOT be finalized by the receiver"
	(aBpmTaskAssignment user == self) ifFalse: [^BpmAssignmentFinalization on: aBpmTaskAssignment by: self].

	"regular assignment with one role only"
	aBpmTaskAssignment hasPerformers ifFalse: [^self basicFinalizeAssignment: aBpmTaskAssignment takeNext: aBoolean]. 

	"more than one role is going to work with this assignment "
	aBpmTaskAssignment incrementPerformerCounter.
	aBpmTaskAssignment isFinishedByPerformers ifTrue: [^self basicFinalizeAssignment: aBpmTaskAssignment takeNext: aBoolean].

	self moveFromCurrentToFinished: aBpmTaskAssignment. "finalized by a Performer (NOT all performers have worked on the task)"
	aBpmTaskAssignment free.

	^BpmAssignmentFinalization on: aBpmTaskAssignment by: self "assignment not finalized"! !

!BpmUser methodsFor: 'assignment' stamp: 'brunobb 12/27/2017 15:08'!
getAllAvailableTaskAssignments
	"Answer a collection with all available assignments <BpmTaskAssignment> for the receiver"
	| assignments |

	assignments := OrderedCollection new.
	self roles do: [:eachRole | | matrix |
		matrix := self getMatrixManagerClass getMatrixForApplicationNamed: eachRole getApplicationName.
		assignments addAll: (matrix getAvailableTasksFor: eachRole name)].

	^assignments select: [:each | each isAvailableFor: self]. "check for runtime context"! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 08/06/2016 11:57'!
getAllFinishedMatrix
	"Answer a collection of <BpmFinishedTasksMatrix> where the receiver has access."

	^self getApplications collect: [:each | self getFinishedMatrixManagerClass getMatrixForApplicationNamed: each applicationName]! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 08/06/2016 12:12'!
getAllFinishedTaskAssignmentsWithId: processId
	"Answer a collection with all assignments <BpmTaskAssignment> where the <BpmProcess> id is equal to <processId>"
	| assignments |

	assignments := OrderedCollection new.
	self roles do: [:eachRole | | matrix |
		matrix := self getFinishedMatrixManagerClass getMatrixForApplicationNamed: eachRole getApplicationName.
		assignments addAll: (matrix getAvailableTasksFor: eachRole name satisfying: {:each | each.processId = processId}).
	].

	^assignments select: [:each | each isAvailableFor: self].! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 08/06/2016 11:57'!
getAllMatrix
	"Answer a collection of <BpmFinishedTasksMatrix> where the receiver can take assignments"

	^self getApplications collect: [:each | self getMatrixManagerClass getMatrixForApplicationNamed: each applicationName]! !

!BpmUser methodsFor: 'processes' stamp: 'BrunoBB 03/14/2016 10:35'!
getAllProcessDefinition
	"Answer a collection with all process's definitions <BpmProcessDefinition> that the receiver has access"
	| allDefinitions definitionCache |

	allDefinitions := OrderedCollection new.
	definitionCache := self getProcessDefinitionCache.
	"backoffice user and admin --> can see all applications"
	((self isBackofficeUserAndAdmin) ifTrue: [self getVisibleApplications] ifFalse: [self getApplications]) 
		do: [:each | | appDictionary |
			appDictionary := definitionCache at: each applicationName ifAbsent: [OrderedCollection new].
			appDictionary do: [:procCollection |
				procCollection notEmpty
				ifTrue: [procCollection last isTopProcess 
							ifTrue: [allDefinitions addAll: procCollection]].
			].
		].

	^allDefinitions! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 08/06/2016 12:12'!
getAllTaskAssignmentsWithId: processId
	"Answer a collection with all assignments <BpmTaskAssignment> where the <BpmProcess> id is equal to <processId>"
	| assignments |

	assignments := OrderedCollection new.
	self roles do: [:eachRole | | matrix |
		matrix := self getMatrixManagerClass getMatrixForApplicationNamed: eachRole getApplicationName.
		assignments addAll: (matrix getAvailableTasksFor: eachRole name satisfying: {:each | each.processId = processId})
	].

	^assignments select: [:each | each isAvailableFor: self].! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 07/04/2016 11:50'!
getApplications
	"The receiver answer a collection with all <Applications> that has a related role <aBpmRole> with the receiver"

	^(roles collect: [:eachRole | eachRole application]) asSet asOrderedCollection! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/10/2016 03:33'!
getAverageTimeForAllTasks

	^self getAverageTimeForTasksIn: self getFinishedAssigments! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/10/2016 03:33'!
getAverageTimeForTasksFrom: startDate to: endDate

	^self getAverageTimeForTasksFrom: startDate to: endDate satisfying: [:e | true]! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/13/2016 10:03'!
getAverageTimeForTasksFrom: startDate to: endDate satisfying: conditionBlock
	| filteredAssignments |

	filteredAssignments := self getFinishedAssigments select: [:each | ((startDate <= each creationDate) and: [each creationDate <= endDate]) and: [conditionBlock asBpmBlock value: each process]].

	^self getAverageTimeForTasksIn: filteredAssignments! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/10/2016 03:32'!
getAverageTimeForTasksIn: assignmentCollection
	| distribution totalValues |

	distribution := OrderPreservingDictionary new.
	totalValues := Dictionary new.

	assignmentCollection do: [:eachAssingment | | currentValue |
		currentValue := (distribution at: eachAssingment taskName ifAbsent: [0]) + (eachAssingment process getTotalTimeOfTaskNamed: eachAssingment taskName) asSeconds.
		totalValues at: eachAssingment taskName put: ((totalValues at: eachAssingment taskName ifAbsent: [0]) + 1).
		distribution at: eachAssingment taskName put: currentValue.
	].

	distribution keysAndValuesDo: [:key :value | distribution at: key put: (value / (totalValues at: key))].

	^distribution! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/13/2016 10:03'!
getAverageTimeForTasksSatisfying: conditionBlock
	| filteredAssignments |

	filteredAssignments := self getFinishedAssigments select: [:each | conditionBlock asBpmBlock value: each process].

	^self getAverageTimeForTasksIn: filteredAssignments! !

!BpmUser methodsFor: 'applications' stamp: 'BrunoBB 02/09/2016 13:18'!
getBackofficeApplications
	"Answer a collection with all OrbeonApplications that the receiver has access in the BackOffice application"

	self isBackofficeUser ifFalse: [^OrderedCollection new].

	self isBackofficeUserAndAdmin ifTrue: [^self getApplicationsCache].

	^self getApplications! !

!BpmUser methodsFor: 'processes' stamp: 'BrunoBB 12/10/2015 09:00'!
getCreationProcesses
	"Answer a collection of process definitions <BpmTopProcessDefinition> where the receiver has creation permission"

	^self getProcessDefinitionLatestVersions select: [:each | each canCreateProcessInstance: self]! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:57'!
getCurrentAssigments
	"Answer receiver's finished assignment <BpmTaskAssignment>"

	^self getCurrentAssigmentsInbox messages! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 16:59'!
getCurrentAssigmentsInbox
	"Answer the <aBpmUserInbox> used to store the current receiver's assignment <BpmTaskAssignment>"

	^inbox getCurrentAssigmentsInbox! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/11/2016 03:13'!
getCurrentTaskQuantityDistribution

	^self getTaskQuantityDistributionIn: self getCurrentAssigments! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/13/2016 10:03'!
getCurrentTaskQuantityDistributionnFrom: startDate to: endDate satisfying: conditionBlock
	| filteredAssignments |

	filteredAssignments := self getCurrentAssigments select: [:each | ((startDate <= each creationDate) and: [each creationDate <= endDate]) and: [conditionBlock asBpmBlock value: each process]].

	^self getTaskQuantityDistributionIn: filteredAssignments! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:57'!
getFinishedAssigments
	"Answer receiver's finished assignment <BpmTaskAssignment>"

	^self getFinishedAssigmentsInbox messages! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:00'!
getFinishedAssigmentsInbox
	"Answer the <aBpmUserInbox> used to store the finished receiver's assignment <BpmTaskAssignment>"

	^inbox getFinishedAssigmentsInbox! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/11/2016 03:13'!
getFinishedTaskQuantityDistribution

	^self getTaskQuantityDistributionIn: self getFinishedAssigments! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/11/2016 03:15'!
getFinishedTaskQuantityDistributionFrom: startDate to: endDate

	^self getFinishedTaskQuantityDistributionFrom: startDate to: endDate satisfying: [:e | true]! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/13/2016 10:03'!
getFinishedTaskQuantityDistributionFrom: startDate to: endDate satisfying: conditionBlock
	| filteredAssignments |

	filteredAssignments := self getFinishedAssigments select: [:each | ((startDate <= each creationDate) and: [each creationDate <= endDate]) and: [conditionBlock asBpmBlock value: each process]].

	^self getTaskQuantityDistributionIn: filteredAssignments! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:49'!
getGatewayDoneBorderColor

	^self getProperty: 'gateway.borderColor.done'! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:49'!
getGatewayDoneFillColor

	^self getProperty: 'gateway.fillColor.done'! !

!BpmUser methodsFor: 'processes' stamp: 'BrunoBB 12/10/2015 10:47'!
getGrantedArtifacts
	"Answer a collection of artifacts <BpmArtifactDefinition> granted to the receiver"
	| artifacts |

	artifacts := Set new.

	roles do: [:each | artifacts addAll: each tasks].

	^artifacts asOrderedCollection! !

!BpmUser methodsFor: 'processes' stamp: 'BrunoBB 12/10/2015 10:52'!
getGrantedTasks
	"Answer a collection of task <BpmAbstractTaskDefinition> granted to the receiver"

	^self getGrantedArtifacts select: [:each | each isTaskDefinition]! !

!BpmUser methodsFor: 'applications' stamp: 'BrunoBB 02/26/2016 13:42'!
getOrbeonApplications
	"The receiver answer a collection with all <Applications> that has a related role <aBpmRole> with the receiver"

	^self getApplications select: [:each | each isObeonApplication]! !

!BpmUser methodsFor: 'applications' stamp: 'BrunoBB 02/26/2016 13:48'!
getOrbeonBackofficeApplications
	"Answer a collection with all OrbeonApplications that the receiver has access in the BackOffice application"

	self isBackofficeUser ifFalse: [^OrderedCollection new].

	self isBackofficeUserAndAdmin ifTrue: [^self getOrbeonCache].

	^self getOrbeonApplications! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/09/2016 08:06'!
getPossibleTaskDefinitionsQuantityDistribution
	| distribution |

	distribution := OrderPreservingDictionary new.

	self roles do: [:eachRole |
		distribution at: eachRole name put: eachRole numberOfTasks.
	]. 

	^distribution! !

!BpmUser methodsFor: 'processes' stamp: 'BrunoBB 12/13/2015 12:06'!
getProcessDefinitionCategoriesFor: aBpmTaskAssignment

	^(BpmProcessDefinitionCategory  getCategoriesFor: self) 
		select: [:each | each includes: aBpmTaskAssignment]! !

!BpmUser methodsFor: 'processes' stamp: 'brunobb 11/29/2017 15:37'!
getProcessDefinitionLatestVersions
	"Answer a collection with all process's latest versions <BpmProcessDefinition> that the receiver has access"
	| allLatestDefinitions definitionCache |

	allLatestDefinitions := Set new.
	definitionCache := self getProcessDefinitionCache.
	"backoffice user and admin --> can see all applications"
	((self isBackofficeUserAndAdmin) ifTrue: [self getVisibleApplications] ifFalse: [self getApplications]) 
		do: [:each | | appDictionary |
			appDictionary := definitionCache at: each applicationName ifAbsent: [OrderedCollection new].
			appDictionary do: [:procCollection |
				procCollection notEmpty
				ifTrue: [procCollection last isTopProcess 
							ifTrue: [allLatestDefinitions add: procCollection last]].
			].
		].

	^allLatestDefinitions asOrderedCollection! !

!BpmUser methodsFor: 'processes' stamp: 'BrunoBB 12/10/2015 12:49'!
getProcessDefinitionNamed: aString

	^self getProcessDefinitionLatestVersions detect: [:each | each processName = aString] ifNone: [nil]! !

!BpmUser methodsFor: 'processes' stamp: 'BrunoBB 12/13/2015 12:07'!
getProcessInstanceCategoriesFor: aBpmProcessDefinition

	^(BpmProcessInstanceCategory  getCategoriesFor: self) 
		select: [:each | each includes: aBpmProcessDefinition]! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 04:43'!
getProperty: named

	^userOptions getProperty: named ifAbsent: []! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 04:19'!
getProperty: named ifAbsent: aBlock

	^userOptions getProperty: named ifAbsent: aBlock! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:57'!
getReleasedAssigments
	"Answer receiver's released assignment <BpmTaskAssignment>"

	^self getReleasedAssigmentsInbox messages! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:01'!
getReleasedAssigmentsInbox
	"Answer the <aBpmUserInbox> used to store the released receiver's assignment <BpmTaskAssignment>"

	^inbox getReleasedAssigmentsInbox! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:48'!
getSubprocessDoneBorderColor

	^self getProperty: 'subprocess.borderColor.done'! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:48'!
getSubprocessDoneFillColor

	^self getProperty: 'subprocess.fillColor.done'! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:57'!
getSystemNotifications
	"Answer receiver's system notifications <BpmSystemNotification>"

	^self getSystemNotificationsInbox messages! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:01'!
getSystemNotificationsInbox
	"Answer the <aBpmUserInbox> used to store system notifications <BpmSystemNotification>"

	^inbox getSystemNotificationsInbox! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 17:30'!
getSystemRoleStructure
	| grants |

	grants := OrderedCollection new.

	self getVisibleApplications do: [:eachApp | 
		(BpmRole getRolsInApp: eachApp) do: [:eachRole | 
			eachRole users do: [:eachUsr | grants add: (BpmUserGrantConfiguration for: eachUsr app: eachApp role: eachRole)]]
		].

	^grants! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:47'!
getTaskDoneBorderColor

	^self getProperty: 'task.borderColor.done'! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:46'!
getTaskDoneFillColor

	^self getProperty: 'task.fillColor.done'! !

!BpmUser methodsFor: 'distribution' stamp: 'BrunoBB 11/11/2016 03:12'!
getTaskQuantityDistributionIn: assigmentCollection
	| distribution |

	distribution := OrderPreservingDictionary new.

	assigmentCollection do: [:eachAssingment | | currentValue key |
		key := "eachAssingment processName, '.'," eachAssingment taskName.
		currentValue := distribution at: key ifAbsent: [0].
		distribution at: key put: currentValue + 1.
	]. 

	^distribution! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:49'!
getTransitionDoneBorderColor

	^self getProperty: 'transition.borderColor.done'! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:02'!
getUserNotifications
	"Answer receiver's user notifications <BpmUserNotification>"

	^self getUserNotificationsInbox messages! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 04/17/2016 17:02'!
getUserNotificationsInbox
	"Answer the <aBpmUserInbox> used to store user notifications <BpmUserNotification>"

	^inbox getUserNotificationsInbox! !

!BpmUser methodsFor: 'applications' stamp: 'BrunoBB 03/05/2016 09:52'!
getVisibleApplications
	"Answer a collection of users <BpmRole> where the receiver is the admin of each role of the collection"

	self isBackofficeUserAndAdmin ifTrue: [^self getApplicationsCache asOrderedCollection].

	^self getApplications! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 02/08/2016 14:41'!
getVisibleRoles
	"Answer a collection of users <BpmRole> where the receiver is the admin of each role of the collection"
	| orbeonApplications |

	self isBackofficeUser ifFalse: [^OrderedCollection new].

	self isBackofficeUserAndAdmin ifTrue: [^BpmRole getAllRoles].

	orbeonApplications := self getApplications.

	^BpmRole getAllRoles select: [:each | orbeonApplications includes: each application]! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 03/10/2016 07:07'!
getVisibleUsers
	"Answer a collection of users <BpmUser> where the receiver is the admin of each user of the collection"
	| orbeonApplications |

	self isBackofficeUser ifFalse: [^Dictionary new].

	self isBackofficeUserAndAdmin ifTrue: [^BpmUser cache].

	orbeonApplications := self getApplications.

	^BpmUser cache select: [:each | each includesAnyApplicationOf: orbeonApplications]! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 12:37'!
inbox
	^inbox! !

!BpmUser methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 12:37'!
inbox: newValue
	inbox := newValue! !

!BpmUser methodsFor: 'applications' stamp: 'BrunoBB 12/10/2015 11:35'!
includesAnyApplicationOf: anOrderedCollection

	^self getApplications anySatisfy: [:each | anOrderedCollection includes: each]! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 12/20/2015 13:52'!
includesAnyRoleOf: aCollection

	^roles anySatisfy: [:each | aCollection includesIdentical: each]! !

!BpmUser methodsFor: 'inbox' stamp: 'BrunoBB 05/30/2016 14:23'!
includesCurrentAssignment: aBpmTaskAssignment
	"Answer whether or not the receiver includes in the current inbox assignment the assignment <aBpmTaskAssignment>"

	^self getCurrentAssigmentsInbox includesEntry: aBpmTaskAssignment! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 04/13/2016 12:05'!
includesRoleNamed: aString
	"Answer whether or not the receiver includes the role named <aString>"

	^roles anySatisfy: [:each | each name = aString]! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 06/13/2016 09:55'!
initialize

	super initialize.

	roles := Set new.

	userOptions := BpmUserOptions new.

	inbox := BpmUserInbox newMainInboxFor: self.
	outbox := BpmUserOutbox newMainOutboxFor: self.

	centralUser := ApplicationUser new.! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 12/10/2015 11:36'!
isAdmin

	^roles anySatisfy: [:each | each isAdmin]! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 12/09/2015 10:12'!
isBackofficeUser

	^roles anySatisfy: [:each | each isBackofficeRole]! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 12/10/2015 10:29'!
isBackofficeUserAndAdmin

	^roles anySatisfy: [:each | each isBackofficeUserAndAdmin]! !

!BpmUser methodsFor: 'roles' stamp: 'brunobb 12/27/2017 13:23'!
isFrontOfficeUser

	^roles anySatisfy: [:each | each isFrontofficeRole]! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 12/08/2015 09:46'!
languageName

	^userOptions languageName! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 03/15/2016 07:29'!
lateralListPagingSize

	^userOptions lateralListPagingSize! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 03/15/2016 10:07'!
lateralListPagingSize: size

	^userOptions lateralListPagingSize: size! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 12:40'!
migrateFrom: oldUser instVarMap: aMap

	super migrateFrom: oldUser instVarMap: aMap.

"	centralUser := ApplicationUser getExistingOrNewUserNamed: name.
	centralUser password: password."! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 04/17/2016 17:55'!
moveFromCurrentToFinished: aBpmTaskAssignment
	"The receiver move the assignment <aBpmTaskAssignment> from current collection to finished collection"

	self getCurrentAssigmentsInbox removeEntry: aBpmTaskAssignment ifAbsent: [self throwExceptionTaskAssignmentNotFound].

	self getFinishedAssigmentsInbox acceptEntry: aBpmTaskAssignment.! !

!BpmUser methodsFor: 'assignment' stamp: 'BrunoBB 04/17/2016 20:09'!
moveFromCurrentToReleased: aBpmTaskAssignment
	"The receiver move the assignment <aBpmTaskAssignment> from current inbox to released inbox"

	self getCurrentAssigmentsInbox removeEntry: aBpmTaskAssignment ifAbsent: [self throwExceptionTaskAssignmentNotFound].

	self getReleasedAssigmentsInbox acceptEntry: aBpmTaskAssignment.! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 12/08/2015 09:46'!
orbeonWebIsLinked

	^userOptions orbeonWebIsLinked! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 12/08/2015 09:46'!
orbeonWebIsLinked: aBoolean

	^userOptions orbeonWebIsLinked: aBoolean! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 12:37'!
outbox
	^outbox! !

!BpmUser methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 12:37'!
outbox: newValue
	outbox := newValue! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:41'!
password
	^centralUser password! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 02/12/2016 10:40'!
password: aString

	centralUser ifNil: [^self].

	centralUser password: aString.! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 04/12/2016 12:20'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', self username, ']'! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 05/14/2016 16:52'!
printResetedPassword
	"Answer the reset password of the receiver if the case. If not answer 'N/A'.
	If hash(1) = 2 --> the password was resetd. See #resetPassword method"

	^centralUser printResetedPassword! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 17:10'!
printSystemRoleStructure
	| structure stream |

	structure := self getSystemRoleStructure.
	stream := PrintStream on: String new.

	structure do: [:each | 
		stream nextPutAll: each applicationName, ';'.
		stream nextPutAll: each printApplicationType, ';'.
		stream nextPutAll: each role name, ';'.
		stream nextPutAll: each printRoleType, ';'.
		stream nextPutAll: each user username.
		stream nextPutAll: String lf.
 ].

	^stream contents! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 03/15/2016 07:29'!
regularListPagingSize

	^userOptions regularListPagingSize! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 03/15/2016 10:07'!
regularListPagingSize: size

	^userOptions regularListPagingSize: size! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 11:47'!
removeFromCache

	^self class cache removeKey: self username ifAbsent: []! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 04:20'!
removeProperty: named

	^userOptions removeProperty: named! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 11/22/2015 13:21'!
removeRole: aBpmRole

	^roles remove: aBpmRole ifAbsent: [nil]! !

!BpmUser methodsFor: 'distribution report' stamp: 'BrunoBB 11/09/2016 08:31'!
reportAverageTimePerTask
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getAverageTimeForAllTasks].
 
	^(BpmUserDistributionReport userName: self username distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmUser methodsFor: 'distribution report' stamp: 'BrunoBB 11/10/2016 03:32'!
reportAverageTimePerTaskFrom: startDate to: endDate
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getAverageTimeForAllTasksFrom: startDate to: endDate].
 
	^(BpmUserDistributionReport userName: self username distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmUser methodsFor: 'distribution report' stamp: 'BrunoBB 11/11/2016 03:01'!
reportAverageTimePerTaskFrom: startDate to: endDate satisfying: conditionBlock
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getAverageTimeForTasksFrom: startDate to: endDate satisfying: conditionBlock].
 
	^(BpmUserDistributionReport userName: self username distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmUser methodsFor: 'distribution report' stamp: 'BrunoBB 11/08/2016 14:20'!
reportCurrentTaskQuantity
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getCurrentTaskQuantityDistribution].
 
	^(BpmUserDistributionReport userName: self username distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmUser methodsFor: 'distribution report' stamp: 'BrunoBB 11/08/2016 14:16'!
reportFinishedTaskQuantity
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getFinishedTaskQuantityDistribution].
 
	^(BpmUserDistributionReport userName: self username distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmUser methodsFor: 'distribution report' stamp: 'BrunoBB 11/11/2016 03:17'!
reportFinishedTaskQuantityFrom: startDate to: endDate satisfying: conditionBlock
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getFinishedTaskQuantityDistributionFrom: startDate to: endDate satisfying: conditionBlock].
 
	^(BpmUserDistributionReport userName: self username distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmUser methodsFor: 'distribution report' stamp: 'BrunoBB 11/09/2016 08:06'!
reportPossibleTaskDefinitionsQuantity
	| secondsToRun distribution |

	secondsToRun := Time secondsElapsedTime: [distribution := self getPossibleTaskDefinitionsQuantityDistribution].
 
	^(BpmUserDistributionReport userName: self username distribution: distribution)
		sumSecondsToConstruct: secondsToRun;
		yourself.! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 08/05/2016 10:03'!
resetAll
	"Reset all user's inboxes"

	self getCurrentAssigmentsInbox resetMessages.
	self getFinishedAssigmentsInbox resetMessages.
	self getReleasedAssigmentsInbox resetMessages.

	roles := Set new.! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 05/14/2016 15:47'!
resetPassword
	"Reset the password of the receiver"

	^centralUser resetPassword! !

!BpmUser methodsFor: 'roles' stamp: 'BrunoBB 12/11/2015 09:27'!
roleName
	| roleName |

	roleName := ''.
	roles isEmpty ifTrue: [^'[]'].

	roles do: [:each | roleName := roleName, '[', each name, ']'].

	^roleName! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 11/22/2015 13:19'!
roles
	^roles! !

!BpmUser methodsFor: 'Updating' stamp: 'BrunoBB 11/22/2015 13:19'!
roles: newValue
	roles := newValue! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 02/12/2016 10:39'!
setCentralUserNamed: aString

	centralUser := ApplicationUser getExistingOrNewUserNamed: aString.! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:55'!
setGatewayDoneBorderColor: aValue

	^self atProperty: 'gateway.borderColor.done' put: aValue! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:55'!
setGatewayDoneFillColor: aValue

	^self atProperty: 'gateway.fillColor.done' put: aValue! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 12/08/2015 09:46'!
setLanguage: symbolLanguage

	userOptions languageName: symbolLanguage asSymbol! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:56'!
setSubprocessDoneBorderColor: aValue

	^self atProperty: 'subprocess.borderColor.done' put: aValue! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:56'!
setSubprocessDoneFillColor: aValue

	^self atProperty: 'subprocess.fillColor.done' put: aValue! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:56'!
setTaskDoneBorderColor: aValue

	^self atProperty: 'task.borderColor.done' put: aValue! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:57'!
setTaskDoneFillColor: aValue

	^self atProperty: 'task.fillColor.done' put: aValue! !

!BpmUser methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 05:57'!
setTransitionDoneBorderColor: aValue

	^self atProperty: 'transition.borderColor.done' put: aValue! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 12/08/2015 09:46'!
setTransitionsDisplayMode: aBoolean

	^userOptions setTransitionsDisplayMode: aBoolean! !

!BpmUser methodsFor: 'assignment' stamp: 'brunobb 01/12/2018 13:02'!
take: aBpmTaskAssignment
	"The receiver take the unassigned task <aBpmTaskAssignment>"

	aBpmTaskAssignment processIsRunning ifFalse: [^ProcessNotRunningException signal: 'The assignment can not be taken by the user because the process is NOT [running]'].

	aBpmTaskAssignment 
		removeFromMatrix; "is not available for other users to take it"
		setAssignationDate; "time stamp when the task was taken"
		registerInProcess. "for historic purpose"

	self getCurrentAssigmentsInbox acceptEntry: aBpmTaskAssignment. "store the assignment in the current assignment inbox"

	aBpmTaskAssignment user: self.

	aBpmTaskAssignment hasPerformers 
	ifTrue: [aBpmTaskAssignment addWorkerUser: self] "add a user and a role to the BpmTaskInstace"! !

!BpmUser methodsFor: 'user preferences' stamp: 'BrunoBB 12/08/2015 09:46'!
transitionDisplayModeIsExpanded

	^userOptions transitionDisplayModeIsExpanded! !

!BpmUser methodsFor: 'assignment' stamp: 'brunobb 01/12/2018 13:03'!
untake: aBpmTaskAssignment
	"The receiver untake the assigned task <aBpmTaskAssignment>"

	aBpmTaskAssignment processIsRunning ifFalse: [^ProcessNotRunningException signal: 'The assignment can not be untaken by the user because the process is NOT [running]'].

	"the task was finalized by the user before the manager could make the untake operation"
	(self includesCurrentAssignment: aBpmTaskAssignment) ifFalse: [^self].

	aBpmTaskAssignment hasPerformers 
	ifTrue: [aBpmTaskAssignment removeLastWorker]. "remove the last user and role from the BpmTaskInstace"

	aBpmTaskAssignment free. "add to free matrix, user set to nil"

	"remove it from the the current assignment inbox"
	"add the assignment to released inbox"
	self moveFromCurrentToReleased: aBpmTaskAssignment.! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 02/12/2016 10:38'!
username
	^centralUser username! !

!BpmUser methodsFor: 'other' stamp: 'BrunoBB 02/12/2016 10:39'!
username: aString

	centralUser ifNil: [self setCentralUserNamed: aString].

	centralUser username: aString.! !

!BpmUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/08/2015 09:45'!
userOptions
	^userOptions! !

!BpmUser methodsFor: 'Updating' stamp: 'BrunoBB 12/08/2015 09:45'!
userOptions: newValue
	userOptions := newValue! !

BpmObject subclass: #BpmUserBox
	instanceVariableNames: 'boxName boxParent boxChildren messages user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmUserBox class methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 11:53'!
newMainInboxFor: aBpmUser

	^(self newNamed: 'Inbox' boxParent: nil for: aBpmUser)
		createInnerBoxes;
		yourself! !

!BpmUserBox class methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 11:57'!
newMainOutboxFor: aBpmUser

	^(self newNamed: 'Outbox' boxParent: nil for: aBpmUser)
		createInnerBoxes;
		yourself! !

!BpmUserBox class methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 11:52'!
newNamed: aString boxParent: aBpmUserBoxOrNil for: aBpmUser

	^super new initialize
		boxName: aString;
		boxParent: aBpmUserBoxOrNil;
		user: aBpmUser;
		yourself! !

!BpmUserBox methodsFor: 'messages' stamp: 'BrunoBB 04/17/2016 16:55'!
acceptEntry: boxEntry
	"The receiver accept the object entry <boxEntry>"

	^messages add: boxEntry! !

!BpmUserBox methodsFor: 'boxes' stamp: 'BrunoBB 04/17/2016 12:24'!
addChildBox: aBpmUserBox
	"The receiver add a child box to it's collection"

	aBpmUserBox boxParent: self.

	^boxChildren at: aBpmUserBox boxName put: aBpmUserBox! !

!BpmUserBox methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 11:34'!
boxChildren
	^boxChildren! !

!BpmUserBox methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 11:34'!
boxChildren: newValue
	boxChildren := newValue! !

!BpmUserBox methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 11:34'!
boxName
	^boxName! !

!BpmUserBox methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 11:34'!
boxName: newValue
	boxName := newValue! !

!BpmUserBox methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 11:34'!
boxParent
	^boxParent! !

!BpmUserBox methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 11:34'!
boxParent: newValue
	boxParent := newValue! !

!BpmUserBox methodsFor: 'boxes' stamp: 'BrunoBB 04/17/2016 11:44'!
createInnerBoxes
	"The receiver create the default inner structure as a tree of boxes"! !

!BpmUserBox methodsFor: 'boxes' stamp: 'BrunoBB 04/17/2016 12:20'!
getAllBoxes
	"Answer all child boxes of the receiver (including it self)"

	^self getAllBoxesOn: OrderedCollection new! !

!BpmUserBox methodsFor: 'boxes' stamp: 'BrunoBB 04/17/2016 12:21'!
getAllBoxesOn: anOrderedCollection
	"Answer all child boxes of the receiver (including it self)"

	(anOrderedCollection includes: self) ifTrue: [^anOrderedCollection].

	anOrderedCollection add: self.

	boxChildren do: [:each | each getAllBoxesOn: anOrderedCollection].

	^anOrderedCollection! !

!BpmUserBox methodsFor: 'boxes' stamp: 'BrunoBB 04/17/2016 12:22'!
getChildBoxNamed: aString
	"Answer the first <BpmUserBox> named <aString>"

	^self getAllBoxes detect: [:each | each boxName = aString] ifNone: [nil]! !

!BpmUserBox methodsFor: 'other' stamp: 'BrunoBB 08/06/2016 11:50'!
getObjectsSatisfying: aBlock
	"Answer a collection of objects in <messages> collection that comply with the query <aBlock>.
	To use indexes: aBlock: 
	{:e | e.processId = 3336433824} "

	^(GsQuery fromSelectBlock: aBlock on: messages) queryResult! !

!BpmUserBox methodsFor: 'messages' stamp: 'BrunoBB 05/30/2016 14:20'!
includesEntry: boxEntry
	"The receiver whether or not includes the entry <boxEntry>"

	^messages includes: boxEntry! !

!BpmUserBox methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 12:24'!
initialize

	super initialize.

	boxName := ''.
	boxChildren := Dictionary new.
	messages := RcIdentityBag new.! !

!BpmUserBox methodsFor: 'messages' stamp: 'BrunoBB 04/17/2016 17:51'!
isEmpty
	"Answer whether or not the receiver is empty"

	^messages isEmpty! !

!BpmUserBox methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 11:29'!
messages
	^messages! !

!BpmUserBox methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 11:29'!
messages: newValue
	messages := newValue! !

!BpmUserBox methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 11:55'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', boxName, ']'! !

!BpmUserBox methodsFor: 'boxes' stamp: 'BrunoBB 04/17/2016 12:24'!
removeChildBox: aBpmUserBox

	aBpmUserBox boxParent: nil.

	^boxChildren removeKey: aBpmUserBox boxName ifAbsent: []! !

!BpmUserBox methodsFor: 'messages' stamp: 'BrunoBB 04/17/2016 17:54'!
removeEntry: boxEntry
	"The receiver remove the object entry <boxEntry>"

	^self removeEntry: boxEntry ifAbsent: []! !

!BpmUserBox methodsFor: 'messages' stamp: 'BrunoBB 04/17/2016 17:53'!
removeEntry: boxEntry ifAbsent: aBlock
	"The receiver remove the object entry <boxEntry> if absent evaluate the zero argument block <aBlock>"

	^messages remove: boxEntry ifAbsent: aBlock! !

!BpmUserBox methodsFor: 'messages' stamp: 'BrunoBB 04/17/2016 17:48'!
resetMessages

	messages := RcIdentityBag new.! !

!BpmUserBox methodsFor: 'Accessing' stamp: 'BrunoBB 04/17/2016 11:42'!
user
	^user! !

!BpmUserBox methodsFor: 'Updating' stamp: 'BrunoBB 04/17/2016 11:42'!
user: newValue
	user := newValue! !

BpmUserBox subclass: #BpmUserInbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmUserInbox methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 16:39'!
createInnerBoxes
	"The receiver create the default inner structure as a tree of boxes"
	| newBox |

	newBox := self class newNamed: self getCurrentAssignmentsName boxParent: self for: user.
	self addChildBox: newBox.

	newBox := self class newNamed: self getFinishedAssignmentsName boxParent: self for: user.
	self addChildBox: newBox.

	newBox := self class newNamed: self getReleasedAssignmentsName boxParent: self for: user.
	self addChildBox: newBox.

	newBox := self class newNamed: self getSystemNotificationsName boxParent: self for: user.
	self addChildBox: newBox.

	newBox := self class newNamed: self getUserNotificationsName boxParent: self for: user.
	self addChildBox: newBox.! !

!BpmUserInbox methodsFor: 'default boxes' stamp: 'BrunoBB 04/17/2016 16:58'!
getCurrentAssigmentsInbox

	^boxChildren 
		at: self getCurrentAssignmentsName 
		ifAbsent: [BasicUserBoxNotFoundException signal: 'There must be a [Current Assignments] inbox']! !

!BpmUserInbox methodsFor: 'default names' stamp: 'BrunoBB 04/17/2016 12:31'!
getCurrentAssignmentsName

	^'Current Assignments'! !

!BpmUserInbox methodsFor: 'default boxes' stamp: 'BrunoBB 04/17/2016 16:59'!
getFinishedAssigmentsInbox

	^boxChildren 
		at: self getFinishedAssignmentsName 
		ifAbsent: [BasicUserBoxNotFoundException signal: 'There must be a [Finished Assignments] inbox']! !

!BpmUserInbox methodsFor: 'default names' stamp: 'BrunoBB 04/17/2016 12:32'!
getFinishedAssignmentsName

	^'Finished Assignments'! !

!BpmUserInbox methodsFor: 'default boxes' stamp: 'BrunoBB 04/17/2016 16:59'!
getReleasedAssigmentsInbox

	^boxChildren 
		at: self getReleasedAssignmentsName 
		ifAbsent: [BasicUserBoxNotFoundException signal: 'There must be a [Released Assignments] inbox']! !

!BpmUserInbox methodsFor: 'default names' stamp: 'BrunoBB 04/17/2016 16:38'!
getReleasedAssignmentsName

	^'Released Assignments'! !

!BpmUserInbox methodsFor: 'default boxes' stamp: 'BrunoBB 04/17/2016 16:59'!
getSystemNotificationsInbox

	^boxChildren 
		at: self getSystemNotificationsName 
		ifAbsent: [BasicUserBoxNotFoundException signal: 'There must be a [System Notifications] inbox']! !

!BpmUserInbox methodsFor: 'default names' stamp: 'BrunoBB 04/17/2016 12:32'!
getSystemNotificationsName

	^'System Notifications'! !

!BpmUserInbox methodsFor: 'default boxes' stamp: 'BrunoBB 04/17/2016 16:59'!
getUserNotificationsInbox

	^boxChildren 
		at: self getUserNotificationsName 
		ifAbsent: [BasicUserBoxNotFoundException signal: 'There must be a [User Notifications] inbox']! !

!BpmUserInbox methodsFor: 'default names' stamp: 'BrunoBB 04/17/2016 12:33'!
getUserNotificationsName

	^'User Notifications'! !

BpmUserBox subclass: #BpmUserOutbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmUserOutbox methodsFor: 'other' stamp: 'BrunoBB 04/17/2016 11:45'!
createInnerBoxes
	"The receiver create the default inner structure as a tree of boxes"! !

BpmObject subclass: #BpmUserOptions
	instanceVariableNames: 'orbeonWebIsLinked languageName initialTransitionDisplayMode lateralListPagingSize regularListPagingSize applicationOptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 06/11/2016 14:31'!
applicationOptions
	^applicationOptions! !

!BpmUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 06/11/2016 14:31'!
applicationOptions: newValue
	applicationOptions := newValue! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 14:33'!
atProperty: named put: value

	^applicationOptions at: named put: value! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 14:46'!
getBooleanTableBackcolor

	^self getProperty: 'booleanTable.backcolor'! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 15:19'!
getBooleanTableBackcolor: backcolor

	^self atProperty: 'booleanTable.backcolor' put: backcolor! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 14:46'!
getProperty: named

	^self getProperty: named ifAbsent: ['']! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 14:45'!
getProperty: named ifAbsent: aBlock

	^applicationOptions at: named ifAbsent: aBlock! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 14:48'!
getSelectTableNonSelectedColor

	"SewafSelectTableReport"
	^self getProperty: 'selectTable.nonSelectedColor'! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 15:19'!
getSelectTableNonSelectedColor: backcolor

	"SewafSelectTableReport"

	^self atProperty: 'selectTable.nonSelectedColor' put: backcolor! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 15:07'!
getSelectTableSelectedColor

	"SewafSelectTableReport"
	^self getProperty: 'selectTable.selectedColor'! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 15:18'!
getSelectTableSelectedColor: backcolor

	"SewafSelectTableReport"

	^self atProperty: 'selectTable.selectedColor' put: backcolor! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 14:56'!
getTableReportBackcolor

	"SewafTableReport"
	^self getProperty: 'tableReport.backcolor'! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 06/11/2016 15:18'!
getTableReportBackcolor: backcolor

	"SewafTableReport"
	^self atProperty: 'tableReport.backcolor' put: backcolor! !

!BpmUserOptions methodsFor: 'other' stamp: 'BrunoBB 06/11/2016 14:34'!
initialize

	super initialize.

	"true - WALinkedAssignmentManager, false - WAEmbeddedAssignmentManager"
	orbeonWebIsLinked := true.
	languageName := #english.
	initialTransitionDisplayMode := #expanded.
	lateralListPagingSize := 5.
	regularListPagingSize := 5.
	applicationOptions := Dictionary new.

	self initializeProperties.! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 09/13/2016 09:45'!
initializeProperties

	"SewafSelectTableReport"
	self atProperty: 'selectTable.selectedColor' put: 'white'.
	self atProperty: 'selectTable.nonSelectedColor' put: 'gainsboro'.

	"SewafBooleanTable"
	self atProperty: 'booleanTable.backcolor' put: 'gainsboro'.

	"SewafTableReport"
	self atProperty: 'tableReport.backcolor' put: 'gainsboro'.

	"Bizagi task color"
	self atProperty: 'bizagi.task.borderColor.done' put: '-7780796'.
	self atProperty: 'bizagi.task.fillColor.done' put: '-2517356'.
	self atProperty: 'bizagi.task.borderColor.pending' put: '-13684945'.
	self atProperty: 'bizagi.task.fillColor.pending' put: '-8421505'.
	"Bizagi sub process task color"
	self atProperty: 'bizagi.subprocess.borderColor.done' put: '-7780796'.
	self atProperty: 'bizagi.subprocess.fillColor.done' put: '-2517356'.
	"Bizagi gateway color"
	self atProperty: 'bizagi.gateway.borderColor.done' put: '-7780796'.
	self atProperty: 'bizagi.gateway.fillColor.done' put: '-2517356'.
	"Bizagi transition color"
	self atProperty: 'bizagi.transition.borderColor.done' put: '-7136256'.
	self atProperty: 'bizagi.transition.borderColor.pending' put: '-7136256'.

	"SVG color initialization"
	self atProperty: 'svg.task.fillColor.done' put: 'lightgreen'.
	self atProperty: 'svg.task.fillColor.running' put: 'lightblue'.
	self atProperty: 'svg.task.fillColor.pending' put: 'lightgray'.
	self atProperty: 'svg.task.borderColor.done' put: 'darkgreen'.
	self atProperty: 'svg.task.borderColor.running' put: 'darkblue'.
	self atProperty: 'svg.task.borderColor.pending' put: 'darkgray'.
	self atProperty: 'svg.transition.borderColor.done' put: 'darkgreen'.
	self atProperty: 'svg.transition.borderColor.pending' put: 'red'.! !

!BpmUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 02/07/2016 15:05'!
initialTransitionDisplayMode
	^initialTransitionDisplayMode! !

!BpmUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 02/07/2016 15:05'!
initialTransitionDisplayMode: newValue
	initialTransitionDisplayMode := newValue! !

!BpmUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 02/07/2016 15:05'!
languageName
	^languageName! !

!BpmUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 02/07/2016 15:05'!
languageName: newValue
	languageName := newValue! !

!BpmUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 06:50'!
lateralListPagingSize
	^lateralListPagingSize! !

!BpmUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 06:50'!
lateralListPagingSize: newValue
	lateralListPagingSize := newValue! !

!BpmUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 02/07/2016 15:05'!
orbeonWebIsLinked
	^orbeonWebIsLinked! !

!BpmUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 02/07/2016 15:05'!
orbeonWebIsLinked: newValue
	orbeonWebIsLinked := newValue! !

!BpmUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 06:50'!
regularListPagingSize
	^regularListPagingSize! !

!BpmUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 06:50'!
regularListPagingSize: newValue
	regularListPagingSize := newValue! !

!BpmUserOptions methodsFor: 'properties' stamp: 'BrunoBB 08/02/2016 04:20'!
removeProperty: named

	^applicationOptions removeKey: named ifAbsent: [nil]! !

!BpmUserOptions methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:05'!
setTransitionsDisplayMode: aBoolean

	aBoolean ifTrue: [^initialTransitionDisplayMode := #expanded].

	initialTransitionDisplayMode := #collapsed.! !

!BpmUserOptions methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:05'!
switchTransitionDisplayMode

	initialTransitionDisplayMode := (initialTransitionDisplayMode = #expanded) ifTrue: [#collapsed] ifFalse: [#expanded].! !

!BpmUserOptions methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:05'!
transitionDisplayModeIsExpanded

	^initialTransitionDisplayMode = #expanded! !

AppFieldValueHolder subclass: #BpmFieldValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmSubProcessDefinition methodsFor: '*orbeonBPMRuntime' stamp: 'BrunoBB 11/29/2015 17:29'!
getProcessInstanceClass

	^BpmSubProcessInstance! !

Object subclass: #BpmSeasideIntegrationObject
	instanceVariableNames: 'assignment fieldsValues user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmSeasideIntegrationObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/19/2016 13:35'!
classOf: fieldName
	"Answer a Smalltalk class that represent the type of the field named <fieldName>.
	1. Get the type of the attribute named <fieldName>
	2. Map the type of 1 with a Smalltalk class"

	^self subclassResponsibility! !

!BpmSeasideIntegrationObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/19/2016 13:35'!
getObjectName
	"Answer the name of the receiver to be used as a key to store fields values"

	^self name

"the values of a Orbeon Form and a SeasideModel will be stored in same structure.
No problem so far, even it can be an Orbeon field with the same name as a SeasideModel field.
The only problem here is if the type are different --> can not be stored in the same RC collection "! !

!BpmSeasideIntegrationObject class methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 09:24'!
new

	^super new initialize! !

!BpmSeasideIntegrationObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/19/2016 13:36'!
searchFields
	"Answer a collection with the fields included with optimized (indexes) search "

	^self subclassResponsibility! !

!BpmSeasideIntegrationObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/19/2016 13:36'!
summaryFields
	"Answer a collection with the fields included in the Summary of the receiver"

	^self subclassResponsibility! !

!BpmSeasideIntegrationObject methodsFor: 'Accessing' stamp: 'BrunoBB 12/21/2015 11:58'!
assignment
	^assignment! !

!BpmSeasideIntegrationObject methodsFor: 'Updating' stamp: 'BrunoBB 12/21/2015 11:58'!
assignment: newValue
	assignment := newValue! !

!BpmSeasideIntegrationObject methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 12/14/2015 11:09'!
attributeValueAt: fieldName

	^self subclassResponsibility! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:35'!
classOf: fieldName
	"Answer a Smalltalk class that represent the type of the field named <fieldName>.
	1. Get the type of the attribute named <fieldName>
	2. Map the type of 1 with a Smalltalk class"

	^self class classOf: fieldName! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 04/20/2016 17:02'!
createFieldIndexFor: anAppFieldValue on: aRcIdentityBag
	"The receiver create (initialization - executed only once) an Index for the field named <anAppFieldValue> name.
	The index is created if the field is a search field if not only answer the holder collection <aRcIdentityBag>"

	(self isSearchField: anAppFieldValue name)
	ifTrue: [GsIndexSpec new
				equalityIndex: 'each.value' lastElementClass: (self stTypeOf: anAppFieldValue name);
				createIndexesOn: aRcIdentityBag].

	^aRcIdentityBag! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:32'!
definition

	^self! !

!BpmSeasideIntegrationObject methodsFor: 'form-field-value' stamp: 'BrunoBB 02/14/2016 13:14'!
fieldsValues
	^fieldsValues! !

!BpmSeasideIntegrationObject methodsFor: 'form-field-value' stamp: 'BrunoBB 02/14/2016 13:14'!
fieldsValues: newValue
	fieldsValues := newValue! !

!BpmSeasideIntegrationObject methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 05/11/2016 12:14'!
fieldValueAt: fieldName
	"Answer the converted value (a Smalltalk object) for the field named <fieldName>"

	^self subclassResponsibility! !

!BpmSeasideIntegrationObject methodsFor: 'form-field-value' stamp: 'BrunoBB 02/14/2016 13:14'!
fieldValuesDo: aBlock
	"The receivet iterate over the fields collection <fieldsValues> and apply the one argument <aBlock> in each iteration"

	^fieldsValues do: aBlock! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'brunobb 12/31/2017 12:46'!
formName
	"Answer the name of the receiver to be used as a key to store fields values"

	^self getObjectName

"the values of a Orbeon Form and a SeasideModel will be stored in same structure.
No problem so far, even it can be an Orbeon field with the same name as a SeasideModel field.
The only problem here is if the type are different --> can not be stored in the same RC collection "! !

!BpmSeasideIntegrationObject methodsFor: 'form-field-value' stamp: 'brunobb 12/31/2017 12:40'!
generateFormFieldValueSet
	"The receiver create an IdentitySet <fieldsValues> of form field values <FormFieldValue>. 
	It creates one element <instance subclass of FormFieldValue> per field in the original XML form."

	"#getAllFields answer aDictionary where each key is the name of the field and each value is a collection of string values"
	self getAllFields keysAndValuesDo: [:key :valuesCollection | | valueHolder |
			valueHolder := (fieldsValues includesKey: key) "<fieldsValues at:> answer aFieldValueHolder"
								ifFalse: [fieldsValues at: key put: (BpmFieldValueHolder parentObject: self forFieldNamed: key)]
								ifTrue: [fieldsValues at: key].
			"convert string values to real type values or update added/removed values"
			valueHolder processFieldValueCollection: valuesCollection withFieldClass: (self classOf: key) in: self isStObject: true.
	].! !

!BpmSeasideIntegrationObject methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/14/2016 13:31'!
getAllFields
	"This method (#getAllFields) answer aDictionary where each key is the name of the field and each value is a collection of string values"

	^self subclassResponsibility! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:35'!
getObjectName
	"Answer the name of the receiver to be used as a key to store fields values"

	^self class getObjectName

"the values of a Orbeon Form and a SeasideModel will be stored in same structure.
No problem so far, even it can be an Orbeon field with the same name as a SeasideModel field.
The only problem here is if the type are different --> can not be stored in the same RC collection "! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:43'!
getUserName

	user ifNil: [^''].

	^user username! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'brunobb 12/31/2017 11:41'!
holderValueAt: fieldName
	"Answer the <AppFieldValueHolder> for the field named <fieldName>"

	^fieldsValues at: fieldName ifAbsent: [nil]! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/14/2016 13:14'!
initialize

	super initialize.

	fieldsValues := Dictionary new.! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:34'!
isSearchField: fieldName
	"Answer whether or not the field named <fieldName> is a search field"

	^self searchFields includes: fieldName asString! !

!BpmSeasideIntegrationObject methodsFor: 'Updating' stamp: 'brunobb 01/08/2018 13:13'!
processId

	^assignment processId! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:36'!
searchFields
	"Answer a collection with the fields included with optimized (indexes) search "

	^self class summaryFields! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/17/2016 12:55'!
stTypeOf: attributeName
	"Answer the type (Smalltalk class) of the for the field named <attributeName> if field name is absent answer nil"

	^(self classOf: attributeName) stType! !

!BpmSeasideIntegrationObject methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:36'!
summaryFields
	"Answer a collection with the fields included in the Summary of the receiver"

	^self class summaryFields! !

!BpmSeasideIntegrationObject methodsFor: 'Accessing' stamp: 'BrunoBB 02/23/2016 09:41'!
user
	^user! !

!BpmSeasideIntegrationObject methodsFor: 'Updating' stamp: 'BrunoBB 02/23/2016 09:41'!
user: newValue
	user := newValue! !

!BpmSeasideIntegrationObject methodsFor: 'form-field-value' stamp: 'BrunoBB 02/23/2016 09:29'!
valueAt: fieldName

	^(self class canUnderstand: fieldName asSymbol)
		ifTrue: [self perform: fieldName asSymbol]
		ifFalse: [self attributeValueAt: fieldName]! !

BpmSeasideIntegrationObject subclass: #BpmSeasideTempObject
	instanceVariableNames: 'name password result date time timeStamp quantity isLocal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmSeasideTempObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/23/2016 08:48'!
classOf: fieldName
	"Answer a Smalltalk class that represent the type of the field named <fieldName>.
	1. Get the type of the attribute named <fieldName>
	2. Map the type of 1 with a Smalltalk class"

	(#('name' 'password' 'result') includes: fieldName asString) ifTrue: [^AppFieldStringValue].

	(fieldName asString = 'date') ifTrue: [^AppFieldDateValue].

	(fieldName asString = 'time') ifTrue: [^AppFieldTimeValue].

	(fieldName asString = 'timeStamp') ifTrue: [^AppFieldTimeStampValue].

	(fieldName asString = 'quantity') ifTrue: [^AppFieldNumberValue].

	(fieldName asString = 'isLocal') ifTrue: [^AppFieldBooelanValue].
 
	^AppFieldStringValue! !

!BpmSeasideTempObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/19/2016 13:33'!
getObjectName
	"Answer the name of the receiver to be used as a key to store fields values"

	^'seadide-temp-object'

"the values of a Orbeon Form and a SeasideModel will be stored in same structure.
No problem so far, even it can be an Orbeon field with the same name as a SeasideModel field.
The only problem here is if the type are different --> can not be stored in the same RC collection "! !

!BpmSeasideTempObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/19/2016 13:33'!
searchFields
	"Answer a collection with the fields included with optimized (indexes) search "

	^#('name' 'date' 'isLocal' 'time' 'timeStamp')! !

!BpmSeasideTempObject class methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/19/2016 13:34'!
summaryFields
	"Answer a collection with the fields included in the Summary of the receiver"

	^#('name' 'password' 'date' 'time' 'timeStamp' 'quantity' 'isLocal')! !

!BpmSeasideTempObject methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 09:25'!
acceptOrReject

	^'accept'! !

!BpmSeasideTempObject methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/23/2016 09:36'!
attributeValueAt: fieldName

	(self class allInstVarNames includes: fieldName) ifFalse: [^'No such instance variable [', fieldName, ']'].

	^self instVarNamed: fieldName asString! !

!BpmSeasideTempObject methodsFor: 'Accessing' stamp: 'BrunoBB 02/14/2016 15:02'!
date
	^date! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 02/14/2016 15:02'!
date: newValue
	date := newValue! !

!BpmSeasideTempObject methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 05/11/2016 12:14'!
fieldValueAt: fieldName
	"Answer the converted value (a Smalltalk object) for the field named <fieldName>"

	^(self class canUnderstand: fieldName asSymbol)
		ifTrue: [self perform: fieldName asSymbol]
		ifFalse: [self attributeValueAt: fieldName]! !

!BpmSeasideTempObject methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/14/2016 15:10'!
getAllFields
	"This method (#getAllFields) answer aDictionary where each key is the name of the field and each value is a collection of string values"
	| fields |

	fields := Dictionary new.

	fields at: 'name' put: (OrderedCollection with: name);
			at: 'password' put: (OrderedCollection with: password);
			at: 'date' put: (OrderedCollection with: date);
			at: 'time' put: (OrderedCollection with: time);
			at: 'timeStamp' put: (OrderedCollection with: timeStamp);
			at: 'quantity' put: (OrderedCollection with: quantity);
			at: 'isLocal' put: (OrderedCollection with: isLocal).

	^fields! !

!BpmSeasideTempObject methodsFor: 'other' stamp: 'BrunoBB 02/14/2016 15:04'!
initialize

	super initialize.

	result := 'passed'.
	name := ''.
	password := ''.
	result := ''.
	date := Date today.
	time := Time now.
	timeStamp := TimeStamp now.
	quantity := 0.
	isLocal := true.! !

!BpmSeasideTempObject methodsFor: 'Accessing' stamp: 'BrunoBB 02/14/2016 15:02'!
isLocal
	^isLocal! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 02/14/2016 15:02'!
isLocal: newValue
	isLocal := newValue! !

!BpmSeasideTempObject methodsFor: 'Accessing' stamp: 'BrunoBB 12/14/2015 09:23'!
name
	^name! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 12/14/2015 09:23'!
name: newValue
	name := newValue! !

!BpmSeasideTempObject methodsFor: 'Accessing' stamp: 'BrunoBB 12/14/2015 09:23'!
password
	^password! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 12/14/2015 09:23'!
password: newValue
	password := newValue! !

!BpmSeasideTempObject methodsFor: 'Accessing' stamp: 'BrunoBB 02/14/2016 15:02'!
quantity
	^quantity! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 02/14/2016 15:02'!
quantity: newValue
	quantity := newValue! !

!BpmSeasideTempObject methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 09:23'!
result

	^result! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 12/14/2015 09:23'!
result: newValue
	result := newValue! !

!BpmSeasideTempObject methodsFor: 'Accessing' stamp: 'BrunoBB 02/14/2016 15:02'!
time
	^time! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 02/14/2016 15:02'!
time: newValue
	time := newValue! !

!BpmSeasideTempObject methodsFor: 'Accessing' stamp: 'BrunoBB 02/14/2016 15:02'!
timeStamp
	^timeStamp! !

!BpmSeasideTempObject methodsFor: 'Updating' stamp: 'BrunoBB 02/14/2016 15:02'!
timeStamp: newValue
	timeStamp := newValue! !

!BpmSeasideTempObject methodsFor: 'subclassResponsibility' stamp: 'BrunoBB 02/23/2016 09:25'!
valueAt: fieldName

	^(self class canUnderstand: fieldName asSymbol)
		ifTrue: [self perform: fieldName asSymbol]
		ifFalse: [self attributeValueAt: fieldName]! !

AppLinuxScripts subclass: #BpmAppLinuxScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime'!

!BpmAppLinuxScripts class methodsFor: 'other' stamp: 'BrunoBB 01/16/2017 07:44'!
getShortScriptPath

	^'/shared/repos/BpmFlow'! !

!BpmAppLinuxScripts class methodsFor: 'other' stamp: 'BrunoBB 01/16/2017 08:05'!
getSystemName

	^'BPM'! !

!BpmAppLinuxScripts class methodsFor: 'scripts' stamp: 'BrunoBB 02/07/2017 10:48'!
registerScript

	super registerScript.

	WAOrbeonProcessLayer register.

	WAOrbeonProcessLogin register. 

	WAOrbeonBackofficeLogin register. 

	WABpmProcessCreationStaticMessage register.! !

!BpmAppLinuxScripts class methodsFor: 'scripts' stamp: 'BrunoBB 02/07/2017 10:51'!
unregisterScript

	super unregisterScript.

	WAOrbeonProcessLayer unregister.

	WAOrbeonProcessLogin unregister. 

	WAOrbeonBackofficeLogin unregister. 

	WABpmProcessCreationStaticMessage unregister.! !

!BpmTopProcessDefinition methodsFor: '*orbeonBPMRuntime' stamp: 'BrunoBB 11/29/2015 17:39'!
getProcessInstanceClass

	^BpmTopProcessInstance! !
